import{S as c2,i as l2,s as n2,e as c,k as m,w as v,t as s,M as p2,c as l,d as r,m as h,a as n,x as b,h as o,b as A,G as e,g as $,y as w,q as y,o as k,B as j,v as i2,L as O}from"../../chunks/vendor-hf-doc-builder.js";import{T as Me}from"../../chunks/Tip-hf-doc-builder.js";import{D as z}from"../../chunks/Docstring-hf-doc-builder.js";import{C as D}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as B}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as T}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function d2(x){let p,u;return{c(){p=c("p"),u=s("Step three is optional, but considered a best practice.")},l(g){p=l(g,"P",{});var i=n(p);u=o(i,"Step three is optional, but considered a best practice."),i.forEach(r)},m(g,i){$(g,p,i),e(p,u)},d(g){g&&r(p)}}}function m2(x){let p,u;return{c(){p=c("p"),u=s("Step five is mandatory when using distributed evaluation")},l(g){p=l(g,"P",{});var i=n(p);u=o(i,"Step five is mandatory when using distributed evaluation"),i.forEach(r)},m(g,i){$(g,p,i),e(p,u)},d(g){g&&r(p)}}}function h2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

with accelerator.accumulate():
    for input, output in dataloader:
        outputs = model(input)
        loss = loss_func(outputs)
        loss.backward()
        optimizer.step()
        scheduler.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.accumulate():
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, output <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>        outputs = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>        loss = loss_func(outputs)
<span class="hljs-meta">... </span>        loss.backward()
<span class="hljs-meta">... </span>        optimizer.step()
<span class="hljs-meta">... </span>        scheduler.step()
<span class="hljs-meta">... </span>        optimizer.zero_grad()`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function g2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(mixed_precision="fp16")
with accelerator.autocast():
    train()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.autocast():
<span class="hljs-meta">... </span>    train()`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function f2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=1)
outputs = model(inputs)
loss = loss_fn(outputs, labels)
accelerator.backward(loss)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">1</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = loss_fn(outputs, labels)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function u2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, scheduler = ...
model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
accelerator.free_memory()
del model, optimizer, scheduler`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.free_memory()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">del</span> model, optimizer, scheduler`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function _2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for (input, target) in dataloader:
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    if accelerator.sync_gradients:
        accelerator.clip_grad_norm_(model.parameters(), max_grad_norm)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> (<span class="hljs-built_in">input</span>, target) <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> accelerator.sync_gradients:
<span class="hljs-meta">... </span>        accelerator.clip_grad_norm_(model.parameters(), max_grad_norm)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function $2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(gradient_accumulation_steps=2)
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for (input, target) in dataloader:
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    if accelerator.sync_gradients:
        accelerator.clip_grad_value_(model.parameters(), clip_value)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(gradient_accumulation_steps=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> (<span class="hljs-built_in">input</span>, target) <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> accelerator.sync_gradients:
<span class="hljs-meta">... </span>        accelerator.clip_grad_value_(model.parameters(), clip_value)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function v2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(log_with="tensorboard")
accelerator.init_trackers("my_project")
# Do training
accelerator.end_training()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(log_with=<span class="hljs-string">&quot;tensorboard&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.init_trackers(<span class="hljs-string">&quot;my_project&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Do training</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.end_training()`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function b2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, scheduler = ...
model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
accelerator.free_memory()
del model, optimizer, scheduler`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, scheduler = accelerator.prepare(model, optimizer, scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.free_memory()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">del</span> model, optimizer, scheduler`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function w2(x){let p,u,g,i,f;return i=new D({props:{code:`# Assuming four processes
import torch
from accelerate import Accelerator

accelerator = Accelerator()
process_tensor = torch.tensor([accelerator.process_index])
gathered_tensor = accelerator.gather(process_tensor)
gathered_tensor`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming four processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = torch.tensor([accelerator.process_index])
<span class="hljs-meta">&gt;&gt;&gt; </span>gathered_tensor = accelerator.gather(process_tensor)
<span class="hljs-meta">&gt;&gt;&gt; </span>gathered_tensor
tensor([<span class="hljs-number">0</span>, <span class="hljs-number">1</span>, <span class="hljs-number">2</span>, <span class="hljs-number">3</span>])`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function y2(x){let p,u,g,i,f;return i=new D({props:{code:`# Assuming two processes, with a batch size of 5 on a dataset with 9 samples
import torch
from accelerate import Accelerator

accelerator = Accelerator()
dataloader = torch.utils.data.DataLoader(range(9), batch_size=5)
dataloader = accelerator.prepare(dataloader)
batch = next(iter(dataloader))
gathered_items = accelerator.gather_for_metrics(batch)
len(gathered_items)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two processes, with a batch size of 5 on a dataset with 9 samples</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader = torch.utils.data.DataLoader(<span class="hljs-built_in">range</span>(<span class="hljs-number">9</span>), batch_size=<span class="hljs-number">5</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader = accelerator.prepare(dataloader)
<span class="hljs-meta">&gt;&gt;&gt; </span>batch = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))
<span class="hljs-meta">&gt;&gt;&gt; </span>gathered_items = accelerator.gather_for_metrics(batch)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">len</span>(gathered_items)
<span class="hljs-number">9</span>`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function k2(x){let p,u,g,i,f;return i=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
net = torch.nn.Linear(2, 2)
net = accelerator.prepare(net)
state_dict = accelerator.get_state_dict(net)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>net = torch.nn.Linear(<span class="hljs-number">2</span>, <span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>net = accelerator.prepare(net)
<span class="hljs-meta">&gt;&gt;&gt; </span>state_dict = accelerator.get_state_dict(net)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function j2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(log_with="tensorboard")
accelerator.init_trackers("my_project")
tensorboard_tracker = accelerator.get_tracker("tensorboard")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(log_with=<span class="hljs-string">&quot;tensorboard&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.init_trackers(<span class="hljs-string">&quot;my_project&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>tensorboard_tracker = accelerator.get_tracker(<span class="hljs-string">&quot;tensorboard&quot;</span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function A2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(log_with="tensorboard")
accelerator.init_trackers(
    project_name="my_project",
    config={"learning_rate": 0.001, "batch_size": 32},
    init_kwargs={"tensorboard": {"flush_secs": 60}},
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(log_with=<span class="hljs-string">&quot;tensorboard&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.init_trackers(
<span class="hljs-meta">... </span>    project_name=<span class="hljs-string">&quot;my_project&quot;</span>,
<span class="hljs-meta">... </span>    config={<span class="hljs-string">&quot;learning_rate&quot;</span>: <span class="hljs-number">0.001</span>, <span class="hljs-string">&quot;batch_size&quot;</span>: <span class="hljs-number">32</span>},
<span class="hljs-meta">... </span>    init_kwargs={<span class="hljs-string">&quot;tensorboard&quot;</span>: {<span class="hljs-string">&quot;flush_secs&quot;</span>: <span class="hljs-number">60</span>}},
<span class="hljs-meta">... </span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function E2(x){let p,u,g,i;return{c(){p=c("p"),u=c("code"),g=s("join_uneven_inputs"),i=s(` is only supported for Distributed Data Parallel training on multiple GPUs. For any other
configuration, this method will have no effect.`)},l(f){p=l(f,"P",{});var t=n(p);u=l(t,"CODE",{});var d=n(u);g=o(d,"join_uneven_inputs"),d.forEach(r),i=o(t,` is only supported for Distributed Data Parallel training on multiple GPUs. For any other
configuration, this method will have no effect.`),t.forEach(r)},m(f,t){$(f,p,t),e(p,u),e(u,g),e(p,i)},d(f){f&&r(p)}}}function x2(x){let p,u,g,i,f;return{c(){p=c("p"),u=s("Overidding "),g=c("code"),i=s("even_batches"),f=s(" will not affect iterable-style data loaders.")},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Overidding "),g=l(d,"CODE",{});var I=n(g);i=o(I,"even_batches"),I.forEach(r),f=o(d," will not affect iterable-style data loaders."),d.forEach(r)},m(t,d){$(t,p,d),e(p,u),e(p,g),e(g,i),e(p,f)},d(t){t&&r(p)}}}function P2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(even_batches=True)
ddp_model, optimizer, dataloader = accelerator.prepare(model, optimizer, dataloader)

with accelerator.join_uneven_inputs([ddp_model], even_batches=False):
    for input, output in dataloader:
        outputs = model(input)
        loss = loss_func(outputs)
        loss.backward()
        optimizer.step()
        optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(even_batches=<span class="hljs-literal">True</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ddp_model, optimizer, dataloader = accelerator.prepare(model, optimizer, dataloader)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.join_uneven_inputs([ddp_model], even_batches=<span class="hljs-literal">False</span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">for</span> <span class="hljs-built_in">input</span>, output <span class="hljs-keyword">in</span> dataloader:
<span class="hljs-meta">... </span>        outputs = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>        loss = loss_func(outputs)
<span class="hljs-meta">... </span>        loss.backward()
<span class="hljs-meta">... </span>        optimizer.step()
<span class="hljs-meta">... </span>        optimizer.zero_grad()`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function D2(x){let p,u,g,i,f;return{c(){p=c("p"),u=s("Should only be used in conjunction with "),g=c("a"),i=s("Accelerator.save_state()"),f=s("."),this.h()},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Should only be used in conjunction with "),g=l(d,"A",{href:!0});var I=n(g);i=o(I,"Accelerator.save_state()"),I.forEach(r),f=o(d,"."),d.forEach(r),this.h()},h(){A(g,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.save_state")},m(t,d){$(t,p,d),e(p,u),e(p,g),e(g,i),e(p,f)},d(t){t&&r(p)}}}function z2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, lr_scheduler = ...
model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
accelerator.load_state("my_checkpoint")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.load_state(<span class="hljs-string">&quot;my_checkpoint&quot;</span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function T2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
with accelerator.local_main_process_first():
    # This will be printed first by local process 0 then in a seemingly
    # random order by the other processes.
    print(f"This will be printed by process {accelerator.local_process_index}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.local_main_process_first():
<span class="hljs-meta">... </span>    <span class="hljs-comment"># This will be printed first by local process 0 then in a seemingly</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># random order by the other processes.</span>
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;This will be printed by process <span class="hljs-subst">{accelerator.local_process_index}</span>&quot;</span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function O2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator(log_with="tensorboard")
accelerator.init_trackers("my_project")
accelerator.log({"loss": 0.5, "accuracy": 0.9})`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator(log_with=<span class="hljs-string">&quot;tensorboard&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.init_trackers(<span class="hljs-string">&quot;my_project&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.log({<span class="hljs-string">&quot;loss&quot;</span>: <span class="hljs-number">0.5</span>, <span class="hljs-string">&quot;accuracy&quot;</span>: <span class="hljs-number">0.9</span>})`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function L2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
with accelerator.main_process_first():
    # This will be printed first by process 0 then in a seemingly
    # random order by the other processes.
    print(f"This will be printed by process {accelerator.process_index}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.main_process_first():
<span class="hljs-meta">... </span>    <span class="hljs-comment"># This will be printed first by process 0 then in a seemingly</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># random order by the other processes.</span>
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;This will be printed by process <span class="hljs-subst">{accelerator.process_index}</span>&quot;</span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function I2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
dataloader, model, optimizer = accelerator.prepare(dataloader, model, optimizer)
input_a = next(iter(dataloader))
input_b = next(iter(dataloader))

with accelerator.no_sync():
    outputs = model(input_a)
    loss = loss_func(outputs)
    accelerator.backward(loss)
    # No synchronization across processes, only accumulate gradients
outputs = model(input_b)
accelerator.backward(loss)
# Synchronization across all processes
optimizer.step()
optimizer.zero_grad()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer = accelerator.prepare(dataloader, model, optimizer)
<span class="hljs-meta">&gt;&gt;&gt; </span>input_a = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))
<span class="hljs-meta">&gt;&gt;&gt; </span>input_b = <span class="hljs-built_in">next</span>(<span class="hljs-built_in">iter</span>(dataloader))

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.no_sync():
<span class="hljs-meta">... </span>    outputs = model(input_a)
<span class="hljs-meta">... </span>    loss = loss_func(outputs)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    <span class="hljs-comment"># No synchronization across processes, only accumulate gradients</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(input_b)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Synchronization across all processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.step()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer.zero_grad()`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function S2(x){let p,u,g,i,f;return i=new D({props:{code:`# Assuming two processes, with the first processes having a tensor of size 1 and the second of size 2
import torch
from accelerate import Accelerator

accelerator = Accelerator()
process_tensor = torch.arange(accelerator.process_index + 1).to(accelerator.device)
padded_tensor = accelerator.pad_across_processes(process_tensor)
padded_tensor.shape`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two processes, with the first processes having a tensor of size 1 and the second of size 2</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = torch.arange(accelerator.process_index + <span class="hljs-number">1</span>).to(accelerator.device)
<span class="hljs-meta">&gt;&gt;&gt; </span>padded_tensor = accelerator.pad_across_processes(process_tensor)
<span class="hljs-meta">&gt;&gt;&gt; </span>padded_tensor.shape
torch.Size([<span class="hljs-number">2</span>])`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function C2(x){let p,u;return{c(){p=c("p"),u=s("You don\u2019t need to prepare a model if you only use it for inference without any kind of mixed precision")},l(g){p=l(g,"P",{});var i=n(p);u=o(i,"You don\u2019t need to prepare a model if you only use it for inference without any kind of mixed precision"),i.forEach(r)},m(g,i){$(g,p,i),e(p,u)},d(g){g&&r(p)}}}function q2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
# Assume a model, optimizer, data_loader and scheduler are defined
model, optimizer, data_loader, scheduler = accelerator.prepare(model, optimizer, data_loader, scheduler)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assume a model, optimizer, data_loader and scheduler are defined</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, data_loader, scheduler = accelerator.prepare(model, optimizer, data_loader, scheduler)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function N2(x){let p,u,g,i,f;return i=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
data_loader = torch.utils.data.DataLoader(...)
data_loader = accelerator.prepare_data_loader(data_loader, device_placement=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>data_loader = torch.utils.data.DataLoader(...)
<span class="hljs-meta">&gt;&gt;&gt; </span>data_loader = accelerator.prepare_data_loader(data_loader, device_placement=<span class="hljs-literal">True</span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function M2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
# Assume a model is defined
model = accelerator.prepare_model(model)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assume a model is defined</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = accelerator.prepare_model(model)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function U2(x){let p,u,g,i,f;return i=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
optimizer = torch.optim.Adam(...)
optimizer = accelerator.prepare_optimizer(optimizer, device_placement=True)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = torch.optim.Adam(...)
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = accelerator.prepare_optimizer(optimizer, device_placement=<span class="hljs-literal">True</span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function R2(x){let p,u,g,i,f;return i=new D({props:{code:`import torch
from accelerate import Accelerator

accelerator = Accelerator()
optimizer = torch.optim.Adam(...)
scheduler = torch.optim.lr_scheduler.LambdaLR(optimizer, ...)
scheduler = accelerator.prepare_scheduler(scheduler)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = torch.optim.Adam(...)
<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = torch.optim.lr_scheduler.LambdaLR(optimizer, ...)
<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = accelerator.prepare_scheduler(scheduler)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function G2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
accelerator.print("Hello world!")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.<span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Hello world!&quot;</span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function V2(x){let p,u,g,i,f;return i=new D({props:{code:`# Assuming two processes
import torch
from accelerate import Accelerator

accelerator = Accelerator()
process_tensor = torch.arange(accelerator.num_processes) + 1 + (2 * accelerator.process_index)
process_tensor = process_tensor.to(accelerator.device)
reduced_tensor = accelerator.reduce(process_tensor, reduction="sum")
reduced_tensor`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = torch.arange(accelerator.num_processes) + <span class="hljs-number">1</span> + (<span class="hljs-number">2</span> * accelerator.process_index)
<span class="hljs-meta">&gt;&gt;&gt; </span>process_tensor = process_tensor.to(accelerator.device)
<span class="hljs-meta">&gt;&gt;&gt; </span>reduced_tensor = accelerator.reduce(process_tensor, reduction=<span class="hljs-string">&quot;sum&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>reduced_tensor
tensor([<span class="hljs-number">4</span>, <span class="hljs-number">6</span>])`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function W2(x){let p,u,g,i,f,t,d,I,Ue,ht,J;return{c(){p=c("p"),u=s("Every "),g=c("code"),i=s("object"),f=s(" must have a "),t=c("code"),d=s("load_state_dict"),I=s(" and "),Ue=c("code"),ht=s("state_dict"),J=s(" function to be stored.")},l(Re){p=l(Re,"P",{});var q=n(p);u=o(q,"Every "),g=l(q,"CODE",{});var Ws=n(g);i=o(Ws,"object"),Ws.forEach(r),f=o(q," must have a "),t=l(q,"CODE",{});var Hs=n(t);d=o(Hs,"load_state_dict"),Hs.forEach(r),I=o(q," and "),Ue=l(q,"CODE",{});var sr=n(Ue);ht=o(sr,"state_dict"),sr.forEach(r),J=o(q," function to be stored."),q.forEach(r)},m(Re,q){$(Re,p,q),e(p,u),e(p,g),e(g,i),e(p,f),e(p,t),e(t,d),e(p,I),e(p,Ue),e(Ue,ht),e(p,J)},d(Re){Re&&r(p)}}}function H2(x){let p,u,g,i,f;return i=new D({props:{code:'from accelerate import Accelerator\n\naccelerator = Accelerator()\n# Assume `CustomObject` has a `state_dict` and `load_state_dict` function.\nobj = CustomObject()\naccelerator.register_for_checkpointing(obj)\naccelerator.save_state("checkpoint.pt")',highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator\n\n<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()\n<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assume `CustomObject` has a `state_dict` and `load_state_dict` function.</span>\n<span class="hljs-meta">&gt;&gt;&gt; </span>obj = CustomObject()\n<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.register_for_checkpointing(obj)\n<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.save_state(<span class="hljs-string">&quot;checkpoint.pt&quot;</span>)'}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function F2(x){let p,u,g,i,f;return{c(){p=c("p"),u=s("Should only be used in conjunction with "),g=c("a"),i=s("Accelerator.register_save_state_pre_hook()"),f=s(`. Can be useful to load
configurations in addition to model weights. Can also be used to overwrite model loading with a customized
method. In this case, make sure to remove already loaded models from the models list.`),this.h()},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Should only be used in conjunction with "),g=l(d,"A",{href:!0});var I=n(g);i=o(I,"Accelerator.register_save_state_pre_hook()"),I.forEach(r),f=o(d,`. Can be useful to load
configurations in addition to model weights. Can also be used to overwrite model loading with a customized
method. In this case, make sure to remove already loaded models from the models list.`),d.forEach(r),this.h()},h(){A(g,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.register_save_state_pre_hook")},m(t,d){$(t,p,d),e(p,u),e(p,g),e(g,i),e(p,f)},d(t){t&&r(p)}}}function Y2(x){let p,u,g,i,f;return{c(){p=c("p"),u=s("Should only be used in conjunction with "),g=c("a"),i=s("Accelerator.register_load_state_pre_hook()"),f=s(`. Can be useful to save
configurations in addition to model weights. Can also be used to overwrite model saving with a customized
method. In this case, make sure to remove already loaded weights from the weights list.`),this.h()},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Should only be used in conjunction with "),g=l(d,"A",{href:!0});var I=n(g);i=o(I,"Accelerator.register_load_state_pre_hook()"),I.forEach(r),f=o(d,`. Can be useful to save
configurations in addition to model weights. Can also be used to overwrite model saving with a customized
method. In this case, make sure to remove already loaded weights from the weights list.`),d.forEach(r),this.h()},h(){A(g,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.register_load_state_pre_hook")},m(t,d){$(t,p,d),e(p,u),e(p,g),e(g,i),e(p,f)},d(t){t&&r(p)}}}function B2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
arr = [0, 1, 2, 3]
accelerator.save(arr, "array.pkl")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>arr = [<span class="hljs-number">0</span>, <span class="hljs-number">1</span>, <span class="hljs-number">2</span>, <span class="hljs-number">3</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.save(arr, <span class="hljs-string">&quot;array.pkl&quot;</span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function J2(x){let p,u;return{c(){p=c("p"),u=s(`Should only be used when wanting to save a checkpoint during training and restoring the state in the same
environment.`)},l(g){p=l(g,"P",{});var i=n(p);u=o(i,`Should only be used when wanting to save a checkpoint during training and restoring the state in the same
environment.`),i.forEach(r)},m(g,i){$(g,p,i),e(p,u)},d(g){g&&r(p)}}}function K2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer, lr_scheduler = ...
model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
accelerator.save_state(output_dir="my_checkpoint")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = ...
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer, lr_scheduler = accelerator.prepare(model, optimizer, lr_scheduler)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.save_state(output_dir=<span class="hljs-string">&quot;my_checkpoint&quot;</span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function Q2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

for (input, target) in accelerator.skip_first_batches(dataloader, num_batches=2):
    optimizer.zero_grad()
    output = model(input)
    loss = loss_func(output, target)
    accelerator.backward(loss)
    optimizer.step()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>dataloader, model, optimizer, scheduler = accelerator.prepare(dataloader, model, optimizer, scheduler)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> (<span class="hljs-built_in">input</span>, target) <span class="hljs-keyword">in</span> accelerator.skip_first_batches(dataloader, num_batches=<span class="hljs-number">2</span>):
<span class="hljs-meta">... </span>    optimizer.zero_grad()
<span class="hljs-meta">... </span>    output = model(<span class="hljs-built_in">input</span>)
<span class="hljs-meta">... </span>    loss = loss_func(output, target)
<span class="hljs-meta">... </span>    accelerator.backward(loss)
<span class="hljs-meta">... </span>    optimizer.step()`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function X2(x){let p,u,g,i,f;return i=new D({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
model, optimizer = accelerator.prepare(model, optimizer)
outputs = model(inputs)
loss = loss_fn(outputs, labels)
accelerator.backward(loss)
accelerator.unscale_gradients(optimizer=optimizer)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model, optimizer = accelerator.prepare(model, optimizer)
<span class="hljs-meta">&gt;&gt;&gt; </span>outputs = model(inputs)
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = loss_fn(outputs, labels)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.backward(loss)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.unscale_gradients(optimizer=optimizer)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function Z2(x){let p,u,g,i,f;return i=new D({props:{code:`# Assuming two GPU processes
from torch.nn.parallel import DistributedDataParallel
from accelerate import Accelerator

accelerator = Accelerator()
model = accelerator.prepare(MyModel())
print(model.__class__.__name__)

model = accelerator.unwrap_model(model)
print(model.__class__.__name__)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two GPU processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> torch.nn.parallel <span class="hljs-keyword">import</span> DistributedDataParallel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span>model = accelerator.prepare(MyModel())
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.__class__.__name__)
DistributedDataParallel

<span class="hljs-meta">&gt;&gt;&gt; </span>model = accelerator.unwrap_model(model)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(model.__class__.__name__)
MyModel`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function ew(x){let p,u,g,i,f;return i=new D({props:{code:`# Assuming two GPU processes
import time
from accelerate import Accelerator

accelerator = Accelerator()
if accelerator.is_main_process:
    time.sleep(2)
else:
    print("I'm waiting for the main process to finish its sleep...")
accelerator.wait_for_everyone()
# Should print on every process at the same time
print("Everyone is here")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two GPU processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> time
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">if</span> accelerator.is_main_process:
<span class="hljs-meta">... </span>    time.sleep(<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">else</span>:
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;I&#x27;m waiting for the main process to finish its sleep...&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator.wait_for_everyone()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Should print on every process at the same time</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Everyone is here&quot;</span>)`}}),{c(){p=c("p"),u=s("Example:"),g=m(),v(i.$$.fragment)},l(t){p=l(t,"P",{});var d=n(p);u=o(d,"Example:"),d.forEach(r),g=h(t),b(i.$$.fragment,t)},m(t,d){$(t,p,d),e(p,u),$(t,g,d),w(i,t,d),f=!0},p:O,i(t){f||(y(i.$$.fragment,t),f=!0)},o(t){k(i.$$.fragment,t),f=!1},d(t){t&&r(p),t&&r(g),j(i,t)}}}function tw(x){let p,u,g,i,f,t,d,I,Ue,ht,J,Re,q,Ws,Hs,sr,Ge,gt,Jo,or,Mi,Ko,Ui,ip,Fs,Ri,dp,he,Ve,Gi,Ys,Vi,Wi,Qo,Hi,Fi,Yi,cr,Bi,Bs,Ji,Ki,Qi,pe,Xi,Xo,Zi,ed,Zo,td,ad,ec,rd,sd,mp,ft,hp,We,ut,od,tc,cd,ld,ac,nd,pd,Js,id,Ks,dd,gp,_t,fp,$t,md,rc,hd,gd,up,He,vt,sc,lr,fd,oc,ud,_p,Fe,bt,cc,nr,_d,lc,$d,$p,Ye,nc,vd,bd,Qs,wd,yd,vp,pr,bp,Be,wt,pc,ir,kd,ic,jd,wp,Je,yt,dc,dr,Ad,mc,Ed,yp,kt,xd,hc,Pd,Dd,kp,mr,jp,jt,zd,Xs,Td,Od,Ap,hr,Ep,Ke,At,gc,gr,Ld,fc,Id,xp,Et,Sd,uc,Cd,qd,Pp,fr,Dp,xt,Nd,Zs,Md,Ud,zp,ur,Tp,Qe,Pt,_c,_r,Rd,$c,Gd,Op,eo,Vd,Lp,$r,Ip,vr,Sp,Xe,Dt,vc,br,Wd,bc,Hd,Cp,zt,Fd,to,Yd,Bd,qp,Ze,Tt,wc,wr,Jd,yc,Kd,Np,Ot,Qd,ao,Xd,Zd,Mp,yr,Up,ge,em,ro,tm,am,kc,rm,sm,Rp,kr,Gp,et,Lt,jc,jr,om,Ac,cm,Vp,Y,lm,It,nm,Ec,pm,im,dm,xc,mm,hm,St,gm,Pc,fm,um,_m,Dc,$m,Wp,tt,Ct,zc,Ar,vm,Tc,bm,Hp,qt,wm,so,ym,km,Fp,Er,Yp,at,Nt,Oc,xr,jm,Lc,Am,Bp,E,Pr,Em,Ic,xm,Pm,Sc,Cc,Dm,zm,L,Mt,qc,Tm,Om,Nc,Lm,Im,Sm,Ut,Mc,Cm,qm,oo,Nm,Mm,Um,Rt,Uc,Rm,Gm,Rc,Vm,Wm,Hm,Gt,Gc,Fm,Ym,Vc,Bm,Jm,Km,Vt,Wc,Qm,Xm,Hc,Zm,eh,th,Wt,Fc,ah,rh,Yc,sh,oh,ch,Ht,Bc,lh,nh,Jc,ph,ih,dh,Ft,Kc,mh,hh,co,gh,fh,uh,Yt,Qc,_h,$h,Xc,vh,bh,wh,Bt,Zc,yh,kh,el,jh,Ah,Eh,fe,Dr,xh,tl,Ph,Dh,Jt,zh,ue,zr,Th,al,Oh,Lh,Kt,Ih,K,Tr,Sh,rt,Ch,rl,qh,Nh,sl,Mh,Uh,Rh,Or,Gh,ol,Vh,Wh,Hh,Qt,Fh,_e,Lr,Yh,Ir,Bh,cl,Jh,Kh,Qh,Xt,Xh,$e,Sr,Zh,Cr,eg,ll,tg,ag,rg,Zt,sg,ve,qr,og,Nr,cg,nl,lg,ng,pg,ea,ig,be,Mr,dg,pl,mg,hg,ta,gg,we,Ur,fg,il,ug,_g,aa,$g,Q,Rr,vg,Gr,bg,dl,wg,yg,kg,ml,jg,Ag,ra,Eg,ye,Vr,xg,Wr,Pg,hl,Dg,zg,Tg,sa,Og,ke,Hr,Lg,Fr,Ig,lo,Sg,Cg,qg,oa,Ng,je,Yr,Mg,ie,Ug,gl,Rg,Gg,fl,Vg,Wg,ul,Hg,Fg,Yg,ca,Bg,Ae,Br,Jg,Jr,Kg,_l,Qg,Xg,Zg,la,ef,W,Kr,tf,Qr,af,$l,rf,sf,of,na,cf,pa,lf,ia,nf,X,Xr,pf,vl,df,mf,da,hf,ma,gf,Z,Zr,ff,bl,uf,_f,wl,$f,vf,ha,bf,Ee,es,wf,st,yf,yl,kf,jf,kl,Af,Ef,xf,ga,Pf,ee,ts,Df,jl,zf,Tf,Al,Of,Lf,fa,If,te,as,Sf,rs,Cf,El,qf,Nf,Mf,ss,Uf,xl,Rf,Gf,Vf,ua,Wf,_a,os,Hf,Pl,Ff,Yf,$a,cs,Bf,Dl,Jf,Kf,va,ls,Qf,zl,Xf,Zf,ba,ns,eu,Tl,tu,au,wa,ps,ru,Ol,su,ou,xe,is,cu,Ll,lu,nu,ya,pu,ae,ds,iu,ms,du,Il,mu,hu,gu,ka,fu,ja,uu,Pe,hs,_u,gs,$u,no,vu,bu,wu,Aa,yu,De,fs,ku,us,ju,po,Au,Eu,xu,Ea,Pu,ze,_s,Du,$s,zu,io,Tu,Ou,Lu,xa,Iu,Te,vs,Su,bs,Cu,mo,qu,Nu,Mu,Pa,Uu,Oe,ws,Ru,ys,Gu,Sl,Vu,Wu,Hu,Da,Fu,re,ks,Yu,ot,Bu,Cl,Ju,Ku,ql,Qu,Xu,Zu,Nl,e_,t_,za,a_,H,js,r_,de,s_,Ml,o_,c_,Ul,l_,n_,Rl,p_,i_,d_,Gl,m_,h_,Ta,g_,Oa,f_,M,As,u_,ct,__,Vl,$_,v_,ho,b_,w_,y_,Wl,k_,j_,Hl,Fl,A_,E_,V,x_,Yl,P_,D_,Bl,z_,T_,Jl,O_,L_,Kl,I_,S_,go,C_,q_,N_,La,M_,U,Es,U_,lt,R_,Ql,G_,V_,fo,W_,H_,F_,Xl,Y_,B_,Zl,en,J_,K_,C,Q_,tn,X_,Z_,an,e$,t$,rn,a$,r$,sn,s$,o$,on,c$,l$,cn,n$,p$,uo,i$,d$,m$,Ia,h$,Le,xs,g$,Ps,f$,ln,u$,_$,$$,Sa,v$,R,Ds,b$,nn,w$,y$,N,k$,pn,j$,A$,dn,E$,x$,mn,P$,D$,hn,z$,T$,gn,O$,L$,fn,I$,S$,C$,zs,q$,un,N$,M$,U$,Ca,R$,qa,G$,Ie,Ts,V$,nt,W$,_n,H$,F$,$n,Y$,B$,J$,Na,K$,se,Os,Q$,vn,X$,Z$,Ma,ev,Ua,tv,bn,av,rv,sv,Ra,ov,wn,cv,lv,nv,Ga,pv,Se,Ls,iv,pt,dv,yn,mv,hv,_o,gv,fv,uv,Va,_v,Ce,Is,$v,kn,vv,bv,Wa,Jp;return t=new B({}),or=new B({}),ft=new Me({props:{$$slots:{default:[d2]},$$scope:{ctx:x}}}),_t=new Me({props:{warning:!0,$$slots:{default:[m2]},$$scope:{ctx:x}}}),lr=new B({}),nr=new B({}),pr=new D({props:{code:`- print("My thing I want to print!")
+ accelerator.print("My thing I want to print!")`,highlighted:`<span class="hljs-deletion">- print(&quot;My thing I want to print!&quot;)</span>
<span class="hljs-addition">+ accelerator.print(&quot;My thing I want to print!&quot;)</span>`}}),ir=new B({}),dr=new B({}),mr=new D({props:{code:`if accelerator.is_local_main_process:
    do_thing_once_per_server()`,highlighted:`<span class="hljs-keyword">if</span> accelerator.is_local_main_process:
    do_thing_once_per_server()`}}),hr=new D({props:{code:`@accelerator.on_local_main_process
def do_my_thing():
    "Something done once per server"
    do_thing_once_per_server()`,highlighted:`<span class="hljs-meta">@accelerator.on_local_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done once per server&quot;</span>
    do_thing_once_per_server()`}}),gr=new B({}),fr=new D({props:{code:`if accelerator.is_main_process:
    do_thing_once()`,highlighted:`<span class="hljs-keyword">if</span> accelerator.is_main_process:
    do_thing_once()`}}),ur=new D({props:{code:`@accelerator.on_main_process
def do_my_thing():
    "Something done once per server"
    do_thing_once()`,highlighted:`<span class="hljs-meta">@accelerator.on_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done once per server&quot;</span>
    do_thing_once()`}}),_r=new B({}),$r=new D({props:{code:`@accelerator.on_local_process(local_process_idx=0)
def do_my_thing():
    "Something done on process index 0 on each server"
    do_thing_on_index_zero_on_each_server()`,highlighted:`<span class="hljs-meta">@accelerator.on_local_process(<span class="hljs-params">local_process_idx=<span class="hljs-number">0</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done on process index 0 on each server&quot;</span>
    do_thing_on_index_zero_on_each_server()`}}),vr=new D({props:{code:`@accelerator.on_process(process_index=0)
def do_my_thing():
    "Something done on process index 0"
    do_thing_on_index_zero()`,highlighted:`<span class="hljs-meta">@accelerator.on_process(<span class="hljs-params">process_index=<span class="hljs-number">0</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">do_my_thing</span>():
    <span class="hljs-string">&quot;Something done on process index 0&quot;</span>
    do_thing_on_index_zero()`}}),br=new B({}),wr=new B({}),yr=new D({props:{code:`model = MyModel()
model = accelerator.prepare(model)
# Unwrap
model = accelerator.unwrap_model(model)`,highlighted:`model = MyModel()
model = accelerator.prepare(model)
<span class="hljs-comment"># Unwrap</span>
model = accelerator.unwrap_model(model)`}}),kr=new D({props:{code:`  state_dict = model.state_dict()
- torch.save(state_dict, "my_state.pkl")
+ accelerator.save(state_dict, "my_state.pkl")`,highlighted:`  state_dict = model.state_dict()
<span class="hljs-deletion">- torch.save(state_dict, &quot;my_state.pkl&quot;)</span>
<span class="hljs-addition">+ accelerator.save(state_dict, &quot;my_state.pkl&quot;)</span>`}}),jr=new B({}),Ar=new B({}),Er=new D({props:{code:`- accelerator = Accelerator()
+ accelerator = Accelerator(gradient_accumulation_steps=2)

  for (input, label) in training_dataloader:
+     with accelerator.accumulate(model):
          predictions = model(input)
          loss = loss_function(predictions, labels)
          accelerator.backward(loss)
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`,highlighted:`<span class="hljs-deletion">- accelerator = Accelerator()</span>
<span class="hljs-addition">+ accelerator = Accelerator(gradient_accumulation_steps=2)</span>

  for (input, label) in training_dataloader:
<span class="hljs-addition">+     with accelerator.accumulate(model):</span>
          predictions = model(input)
          loss = loss_function(predictions, labels)
          accelerator.backward(loss)
          optimizer.step()
          scheduler.step()
          optimizer.zero_grad()`}}),xr=new B({}),Pr=new z({props:{name:"class accelerate.Accelerator",anchor:"accelerate.Accelerator",parameters:[{name:"device_placement",val:": bool = True"},{name:"split_batches",val:": bool = False"},{name:"mixed_precision",val:": typing.Union[accelerate.utils.dataclasses.PrecisionType, str] = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"cpu",val:": bool = False"},{name:"deepspeed_plugin",val:": DeepSpeedPlugin = None"},{name:"fsdp_plugin",val:": FullyShardedDataParallelPlugin = None"},{name:"megatron_lm_plugin",val:": MegatronLMPlugin = None"},{name:"rng_types",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.RNGType]], NoneType] = None"},{name:"log_with",val:": typing.Union[typing.List[typing.Union[str, accelerate.utils.dataclasses.LoggerType, accelerate.tracking.GeneralTracker]], NoneType] = None"},{name:"project_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"project_config",val:": typing.Optional[accelerate.utils.dataclasses.ProjectConfiguration] = None"},{name:"logging_dir",val:": typing.Union[str, os.PathLike, NoneType] = None"},{name:"dispatch_batches",val:": typing.Optional[bool] = None"},{name:"even_batches",val:": bool = True"},{name:"step_scheduler_with_optimizer",val:": bool = True"},{name:"kwargs_handlers",val:": typing.Optional[typing.List[accelerate.utils.dataclasses.KwargsHandler]] = None"},{name:"dynamo_backend",val:": typing.Union[accelerate.utils.dataclasses.DynamoBackend, str] = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the accelerator should put objects on device (tensors yielded by the dataloader, model,
etc&#x2026;).`,name:"device_placement"},{anchor:"accelerate.Accelerator.split_batches",description:`<strong>split_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the accelerator should split the batches yielded by the dataloaders across the devices. If
<code>True</code> the actual batch size used will be the same on any kind of distributed processes, but it must be a
round multiple of the <code>num_processes</code> you are using. If <code>False</code>, actual batch size used will be the one set
in your script multiplied by the number of processes.`,name:"split_batches"},{anchor:"accelerate.Accelerator.mixed_precision",description:`<strong>mixed_precision</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Whether or not to use mixed precision training (fp16 or bfloat16). Choose from &#x2018;no&#x2019;,&#x2018;fp16&#x2019;,&#x2018;bf16&#x2019;. Will
default to the value in the environment variable <code>ACCELERATE_MIXED_PRECISION</code>, which will use the default
value in the accelerate config of the current system or the flag passed with the <code>accelerate.launch</code>
command. &#x2018;fp16&#x2019; requires pytorch 1.6 or higher. &#x2018;bf16&#x2019; requires pytorch 1.10 or higher.`,name:"mixed_precision"},{anchor:"accelerate.Accelerator.gradient_accumulation_steps",description:`<strong>gradient_accumulation_steps</strong> (<code>int</code>, <em>optional</em>, default to 1) &#x2014;
The number of steps that should pass before gradients are accumulated. A number &gt; 1 should be combined with
<code>Accelerator.accumulate</code>. If not passed, will default to the value in the environment variable
<code>ACCELERATE_GRADIENT_ACCUMULATION_STEPS</code>.`,name:"gradient_accumulation_steps"},{anchor:"accelerate.Accelerator.cpu",description:`<strong>cpu</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to force the script to execute on CPU. Will ignore GPU available if set to <code>True</code> and force
the execution on one process only.`,name:"cpu"},{anchor:"accelerate.Accelerator.deepspeed_plugin",description:`<strong>deepspeed_plugin</strong> (<code>DeepSpeedPlugin</code>, <em>optional</em>) &#x2014;
Tweak your DeepSpeed related args using this argument. This argument is optional and can be configured
directly using <em>accelerate config</em>`,name:"deepspeed_plugin"},{anchor:"accelerate.Accelerator.fsdp_plugin",description:`<strong>fsdp_plugin</strong> (<code>FullyShardedDataParallelPlugin</code>, <em>optional</em>) &#x2014;
Tweak your FSDP related args using this argument. This argument is optional and can be configured directly
using <em>accelerate config</em>`,name:"fsdp_plugin"},{anchor:"accelerate.Accelerator.megatron_lm_plugin",description:`<strong>megatron_lm_plugin</strong> (<code>MegatronLMPlugin</code>, <em>optional</em>) &#x2014;
Tweak your MegatronLM related args using this argument. This argument is optional and can be configured
directly using <em>accelerate config</em>`,name:"megatron_lm_plugin"},{anchor:"accelerate.Accelerator.rng_types",description:`<strong>rng_types</strong> (list of <code>str</code> or <code>RNGType</code>) &#x2014;
The list of random number generators to synchronize at the beginning of each iteration in your prepared
dataloaders. Should be one or several of:</p>
<ul>
<li><code>&quot;torch&quot;</code>: the base torch random number generator</li>
<li><code>&quot;cuda&quot;</code>: the CUDA random number generator (GPU only)</li>
<li><code>&quot;xla&quot;</code>: the XLA random number generator (TPU only)</li>
<li><code>&quot;generator&quot;</code>: the <code>torch.Generator</code> of the sampler (or batch sampler if there is no sampler in your
dataloader) or of the iterable dataset (if it exists) if the underlying dataset is of that type.</li>
</ul>
<p>Will default to <code>[&quot;torch&quot;]</code> for PyTorch versions &lt;=1.5.1 and <code>[&quot;generator&quot;]</code> for PyTorch versions &gt;= 1.6.`,name:"rng_types"},{anchor:"accelerate.Accelerator.log_with",description:`<strong>log_with</strong> (list of <code>str</code>, <a href="/docs/accelerate/v0.16.0/en/package_reference/utilities#accelerate.utils.LoggerType">LoggerType</a> or <a href="/docs/accelerate/v0.16.0/en/package_reference/tracking#accelerate.tracking.GeneralTracker">GeneralTracker</a>, <em>optional</em>) &#x2014;
A list of loggers to be setup for experiment tracking. Should be one or several of:</p>
<ul>
<li><code>&quot;all&quot;</code></li>
<li><code>&quot;tensorboard&quot;</code></li>
<li><code>&quot;wandb&quot;</code></li>
<li><code>&quot;comet_ml&quot;</code>
If <code>&quot;all&quot;</code> is selected, will pick up all available trackers in the environment and initialize them. Can
also accept implementations of <code>GeneralTracker</code> for custom trackers, and can be combined with <code>&quot;all&quot;</code>.</li>
</ul>`,name:"log_with"},{anchor:"accelerate.Accelerator.project_config",description:`<strong>project_config</strong> (<code>ProjectConfiguration</code>, <em>optional</em>) &#x2014;
A configuration for how saving the state can be handled.`,name:"project_config"},{anchor:"accelerate.Accelerator.project_dir",description:`<strong>project_dir</strong> (<code>str</code>, <code>os.PathLike</code>, <em>optional</em>) &#x2014;
A path to a directory for storing data such as logs of locally-compatible loggers and potentially saved
checkpoints.`,name:"project_dir"},{anchor:"accelerate.Accelerator.dispatch_batches",description:`<strong>dispatch_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code>, the dataloader prepared by the Accelerator is only iterated through on the main process
and then the batches are split and broadcast to each process. Will default to <code>True</code> for <code>DataLoader</code> whose
underlying dataset is an <code>IterableDataset</code>, <code>False</code> otherwise.`,name:"dispatch_batches"},{anchor:"accelerate.Accelerator.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, in cases where the total batch size across all processes does not exactly divide the
dataset, samples at the start of the dataset will be duplicated so the batch can be divided equally among
all workers.`,name:"even_batches"},{anchor:"accelerate.Accelerator.step_scheduler_with_optimizer",description:"<strong>step_scheduler_with_optimizer</strong> (<code>bool</code>, *optional<code>, defaults to </code>True<code>) -- Set </code>True<code>if the learning rate scheduler is stepped at the same time as the optimizer,</code>False` if only\ndone under certain circumstances (at the end of each epoch, for instance).",name:"step_scheduler_with_optimizer"},{anchor:"accelerate.Accelerator.kwargs_handlers",description:`<strong>kwargs_handlers</strong> (<code>List[KwargHandler]</code>, <em>optional</em>) &#x2014;
A list of <code>KwargHandler</code> to customize how the objects related to distributed training or mixed precision
are created. See <a href="kwargs">kwargs</a> for more information.`,name:"kwargs_handlers"},{anchor:"accelerate.Accelerator.dynamo_backend",description:`<strong>dynamo_backend</strong> (<code>str</code> or <code>DynamoBackend</code>, <em>optional</em>, defaults to <code>&quot;no&quot;</code>) &#x2014;
Set to one of the possible dynamo backends to optimize your training with torch dynamo.`,name:"dynamo_backend"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L112"}}),Dr=new z({props:{name:"accumulate",anchor:"accelerate.Accelerator.accumulate",parameters:[{name:"model",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.accumulate.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
PyTorch Module that was prepared with <code>Accelerator.prepare</code>`,name:"model"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L658"}}),Jt=new T({props:{anchor:"accelerate.Accelerator.accumulate.example",$$slots:{default:[h2]},$$scope:{ctx:x}}}),zr=new z({props:{name:"autocast",anchor:"accelerate.Accelerator.autocast",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L2315"}}),Kt=new T({props:{anchor:"accelerate.Accelerator.autocast.example",$$slots:{default:[g2]},$$scope:{ctx:x}}}),Tr=new z({props:{name:"backward",anchor:"accelerate.Accelerator.backward",parameters:[{name:"loss",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1413"}}),Qt=new T({props:{anchor:"accelerate.Accelerator.backward.example",$$slots:{default:[f2]},$$scope:{ctx:x}}}),Lr=new z({props:{name:"clear",anchor:"accelerate.Accelerator.clear",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L2183"}}),Xt=new T({props:{anchor:"accelerate.Accelerator.clear.example",$$slots:{default:[u2]},$$scope:{ctx:x}}}),Sr=new z({props:{name:"clip_grad_norm_",anchor:"accelerate.Accelerator.clip_grad_norm_",parameters:[{name:"parameters",val:""},{name:"max_norm",val:""},{name:"norm_type",val:" = 2"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1478",returnDescription:`
<p>Total norm of the parameter gradients (viewed as a single vector).</p>
`,returnType:`
<p><code>torch.Tensor</code></p>
`}}),Zt=new T({props:{anchor:"accelerate.Accelerator.clip_grad_norm_.example",$$slots:{default:[_2]},$$scope:{ctx:x}}}),qr=new z({props:{name:"clip_grad_value_",anchor:"accelerate.Accelerator.clip_grad_value_",parameters:[{name:"parameters",val:""},{name:"clip_value",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1516"}}),ea=new T({props:{anchor:"accelerate.Accelerator.clip_grad_value_.example",$$slots:{default:[$2]},$$scope:{ctx:x}}}),Mr=new z({props:{name:"end_training",anchor:"accelerate.Accelerator.end_training",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1854"}}),ta=new T({props:{anchor:"accelerate.Accelerator.end_training.example",$$slots:{default:[v2]},$$scope:{ctx:x}}}),Ur=new z({props:{name:"free_memory",anchor:"accelerate.Accelerator.free_memory",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L2159"}}),aa=new T({props:{anchor:"accelerate.Accelerator.free_memory.example",$$slots:{default:[b2]},$$scope:{ctx:x}}}),Rr=new z({props:{name:"gather",anchor:"accelerate.Accelerator.gather",parameters:[{name:"tensor",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.gather.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors to gather across all processes.`,name:"tensor"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1543",returnDescription:`
<p>The gathered tensor(s). Note that the
first dimension of the result is <em>num_processes</em> multiplied by the first dimension of the input tensors.</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),ra=new T({props:{anchor:"accelerate.Accelerator.gather.example",$$slots:{default:[w2]},$$scope:{ctx:x}}}),Vr=new z({props:{name:"gather_for_metrics",anchor:"accelerate.Accelerator.gather_for_metrics",parameters:[{name:"tensor",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.gather_for_metrics.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors for calculating metrics across all processes.`,name:"tensor"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1575"}}),sa=new T({props:{anchor:"accelerate.Accelerator.gather_for_metrics.example",$$slots:{default:[y2]},$$scope:{ctx:x}}}),Hr=new z({props:{name:"get_state_dict",anchor:"accelerate.Accelerator.get_state_dict",parameters:[{name:"model",val:""},{name:"unwrap",val:" = True"}],parametersDescription:[{anchor:"accelerate.Accelerator.get_state_dict.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A PyTorch model sent through <a href="/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.prepare">Accelerator.prepare()</a>`,name:"model"},{anchor:"accelerate.Accelerator.get_state_dict.unwrap",description:`<strong>unwrap</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to return the original underlying state_dict of <code>model</code> or to return the wrapped state_dict`,name:"unwrap"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L2227",returnDescription:`
<p>The state dictionary of the model potentially without full precision.</p>
`,returnType:`
<p><code>dict</code></p>
`}}),oa=new T({props:{anchor:"accelerate.Accelerator.get_state_dict.example",$$slots:{default:[k2]},$$scope:{ctx:x}}}),Yr=new z({props:{name:"get_tracker",anchor:"accelerate.Accelerator.get_tracker",parameters:[{name:"name",val:": str"}],parametersDescription:[{anchor:"accelerate.Accelerator.get_tracker.name",description:`<strong>name</strong> (<code>str</code>) &#x2014;
The name of a tracker, corresponding to the <code>.name</code> property.`,name:"name"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1797",returnDescription:`
<p>The tracker corresponding to <code>name</code> if it exists.</p>
`,returnType:`
<p><code>GeneralTracker</code></p>
`}}),ca=new T({props:{anchor:"accelerate.Accelerator.get_tracker.example",$$slots:{default:[j2]},$$scope:{ctx:x}}}),Br=new z({props:{name:"init_trackers",anchor:"accelerate.Accelerator.init_trackers",parameters:[{name:"project_name",val:": str"},{name:"config",val:": typing.Optional[dict] = None"},{name:"init_kwargs",val:": typing.Optional[dict] = {}"}],parametersDescription:[{anchor:"accelerate.Accelerator.init_trackers.project_name",description:`<strong>project_name</strong> (<code>str</code>) &#x2014;
The name of the project. All trackers will save their data based on this`,name:"project_name"},{anchor:"accelerate.Accelerator.init_trackers.config",description:`<strong>config</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Optional starting configuration to be logged.`,name:"config"},{anchor:"accelerate.Accelerator.init_trackers.init_kwargs",description:`<strong>init_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A nested dictionary of kwargs to be passed to a specific tracker&#x2019;s <code>__init__</code> function. Should be
formatted like so:`,name:"init_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1749"}}),la=new T({props:{anchor:"accelerate.Accelerator.init_trackers.example",$$slots:{default:[A2]},$$scope:{ctx:x}}}),Kr=new z({props:{name:"join_uneven_inputs",anchor:"accelerate.Accelerator.join_uneven_inputs",parameters:[{name:"joinables",val:""},{name:"even_batches",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.join_uneven_inputs.joinables",description:`<strong>joinables</strong> (<code>List[torch.distributed.algorithms.Joinable]</code>) &#x2014;
A list of models or optimizers that subclass <code>torch.distributed.algorithms.Joinable</code>. Most commonly, a
PyTorch Module that was prepared with <code>Accelerator.prepare</code> for DistributedDataParallel training.`,name:"joinables"},{anchor:"accelerate.Accelerator.join_uneven_inputs.even_batches",description:`<strong>even_batches</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set, this will override the value of <code>even_batches</code> set in the <code>Accelerator</code>. If it is not provided,
the default <code>Accelerator</code> value wil be used.`,name:"even_batches"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L694"}}),na=new Me({props:{warning:!0,$$slots:{default:[E2]},$$scope:{ctx:x}}}),pa=new Me({props:{warning:!0,$$slots:{default:[x2]},$$scope:{ctx:x}}}),ia=new T({props:{anchor:"accelerate.Accelerator.join_uneven_inputs.example",$$slots:{default:[P2]},$$scope:{ctx:x}}}),Xr=new z({props:{name:"load_state",anchor:"accelerate.Accelerator.load_state",parameters:[{name:"input_dir",val:": str"},{name:"**load_model_func_kwargs",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.load_state.input_dir",description:`<strong>input_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The name of the folder all relevant weights and states were saved in.`,name:"input_dir"},{anchor:"accelerate.Accelerator.load_state.load_model_func_kwargs",description:`<strong>load_model_func_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Additional keyword arguments for loading model which can be passed to the underlying load function,
such as optional arguments for DeepSpeed&#x2019;s <code>load_checkpoint</code> function.`,name:"load_model_func_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L2067"}}),da=new Me({props:{$$slots:{default:[D2]},$$scope:{ctx:x}}}),ma=new T({props:{anchor:"accelerate.Accelerator.load_state.example",$$slots:{default:[z2]},$$scope:{ctx:x}}}),Zr=new z({props:{name:"local_main_process_first",anchor:"accelerate.Accelerator.local_main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L583"}}),ha=new T({props:{anchor:"accelerate.Accelerator.local_main_process_first.example",$$slots:{default:[T2]},$$scope:{ctx:x}}}),es=new z({props:{name:"log",anchor:"accelerate.Accelerator.log",parameters:[{name:"values",val:": dict"},{name:"step",val:": typing.Optional[int] = None"},{name:"log_kwargs",val:": typing.Optional[dict] = {}"}],parametersDescription:[{anchor:"accelerate.Accelerator.log.values",description:`<strong>values</strong> (<code>dict</code>) &#x2014;
Values should be a dictionary-like object containing only types <code>int</code>, <code>float</code>, or <code>str</code>.`,name:"values"},{anchor:"accelerate.Accelerator.log.step",description:`<strong>step</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The run step. If included, the log will be affiliated with this step.`,name:"step"},{anchor:"accelerate.Accelerator.log.log_kwargs",description:`<strong>log_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A nested dictionary of kwargs to be passed to a specific tracker&#x2019;s <code>log</code> function. Should be formatted
like so:`,name:"log_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1824"}}),ga=new T({props:{anchor:"accelerate.Accelerator.log.example",$$slots:{default:[O2]},$$scope:{ctx:x}}}),ts=new z({props:{name:"main_process_first",anchor:"accelerate.Accelerator.main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L562"}}),fa=new T({props:{anchor:"accelerate.Accelerator.main_process_first.example",$$slots:{default:[L2]},$$scope:{ctx:x}}}),as=new z({props:{name:"no_sync",anchor:"accelerate.Accelerator.no_sync",parameters:[{name:"model",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.no_sync.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
PyTorch Module that was prepared with <code>Accelerator.prepare</code>`,name:"model"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L604"}}),ua=new T({props:{anchor:"accelerate.Accelerator.no_sync.example",$$slots:{default:[I2]},$$scope:{ctx:x}}}),os=new z({props:{name:"on_last_process",anchor:"accelerate.Accelerator.on_last_process",parameters:[{name:"func",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L511"}}),cs=new z({props:{name:"on_local_main_process",anchor:"accelerate.Accelerator.on_local_main_process",parameters:[{name:"func",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L499"}}),ls=new z({props:{name:"on_local_process",anchor:"accelerate.Accelerator.on_local_process",parameters:[{name:"local_process_idx",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L538"}}),ns=new z({props:{name:"on_main_process",anchor:"accelerate.Accelerator.on_main_process",parameters:[{name:"func",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L487"}}),ps=new z({props:{name:"on_process",anchor:"accelerate.Accelerator.on_process",parameters:[{name:"process_idx",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L523"}}),is=new z({props:{name:"pad_across_processes",anchor:"accelerate.Accelerator.pad_across_processes",parameters:[{name:"tensor",val:""},{name:"dim",val:" = 0"},{name:"pad_index",val:" = 0"},{name:"pad_first",val:" = False"}],parametersDescription:[{anchor:"accelerate.Accelerator.pad_across_processes.tensor",description:`<strong>tensor</strong> (nested list/tuple/dictionary of <code>torch.Tensor</code>) &#x2014;
The data to gather.`,name:"tensor"},{anchor:"accelerate.Accelerator.pad_across_processes.dim",description:`<strong>dim</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The dimension on which to pad.`,name:"dim"},{anchor:"accelerate.Accelerator.pad_across_processes.pad_index",description:`<strong>pad_index</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The value with which to pad.`,name:"pad_index"},{anchor:"accelerate.Accelerator.pad_across_processes.pad_first",description:`<strong>pad_first</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to pad at the beginning or the end.`,name:"pad_first"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1657",returnDescription:`
<p>The padded tensor(s).</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),ya=new T({props:{anchor:"accelerate.Accelerator.pad_across_processes.example",$$slots:{default:[S2]},$$scope:{ctx:x}}}),ds=new z({props:{name:"prepare",anchor:"accelerate.Accelerator.prepare",parameters:[{name:"*args",val:""},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare.*args",description:`<strong>*args</strong> (list of objects) &#x2014;
Any of the following type of objects:</p>
<ul>
<li><code>torch.utils.data.DataLoader</code>: PyTorch Dataloader</li>
<li><code>torch.nn.Module</code>: PyTorch Module</li>
<li><code>torch.optim.Optimizer</code>: PyTorch Optimizer</li>
<li><code>torch.optim.lr_scheduler.LRScheduler</code>: PyTorch LR Scheduler</li>
</ul>`,name:"*args"},{anchor:"accelerate.Accelerator.prepare.device_placement",description:`<strong>device_placement</strong> (<code>List[bool]</code>, <em>optional</em>) &#x2014;
Used to customize whether automatic device placement should be performed for each object passed. Needs
to be a list of the same length as <code>args</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L859"}}),ka=new Me({props:{$$slots:{default:[C2]},$$scope:{ctx:x}}}),ja=new T({props:{anchor:"accelerate.Accelerator.prepare.example",$$slots:{default:[q2]},$$scope:{ctx:x}}}),hs=new z({props:{name:"prepare_data_loader",anchor:"accelerate.Accelerator.prepare_data_loader",parameters:[{name:"data_loader",val:": DataLoader"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_data_loader.data_loader",description:`<strong>data_loader</strong> (<code>torch.utils.data.DataLoader</code>) &#x2014;
A vanilla PyTorch DataLoader to prepare`,name:"data_loader"},{anchor:"accelerate.Accelerator.prepare_data_loader.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the batches on the proper device in the prepared dataloader. Will default to
<code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1310"}}),Aa=new T({props:{anchor:"accelerate.Accelerator.prepare_data_loader.example",$$slots:{default:[N2]},$$scope:{ctx:x}}}),fs=new z({props:{name:"prepare_model",anchor:"accelerate.Accelerator.prepare_model",parameters:[{name:"model",val:": Module"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
A PyTorch model to prepare. You don&#x2019;t need to prepare a model if it is used only for inference without
any kind of mixed precision`,name:"model"},{anchor:"accelerate.Accelerator.prepare_model.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the model on the proper device. Will default to <code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L967"}}),Ea=new T({props:{anchor:"accelerate.Accelerator.prepare_model.example",$$slots:{default:[M2]},$$scope:{ctx:x}}}),_s=new z({props:{name:"prepare_optimizer",anchor:"accelerate.Accelerator.prepare_optimizer",parameters:[{name:"optimizer",val:": Optimizer"},{name:"device_placement",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_optimizer.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.Optimizer</code>) &#x2014;
A vanilla PyTorch optimizer to prepare`,name:"optimizer"},{anchor:"accelerate.Accelerator.prepare_optimizer.device_placement",description:`<strong>device_placement</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to place the optimizer on the proper device. Will default to <code>self.device_placement</code>.`,name:"device_placement"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1349"}}),xa=new T({props:{anchor:"accelerate.Accelerator.prepare_optimizer.example",$$slots:{default:[U2]},$$scope:{ctx:x}}}),vs=new z({props:{name:"prepare_scheduler",anchor:"accelerate.Accelerator.prepare_scheduler",parameters:[{name:"scheduler",val:": _LRScheduler"}],parametersDescription:[{anchor:"accelerate.Accelerator.prepare_scheduler.scheduler",description:`<strong>scheduler</strong> (<code>torch.optim.lr_scheduler.LRScheduler</code>) &#x2014;
A vanilla PyTorch scheduler to prepare`,name:"scheduler"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1377"}}),Pa=new T({props:{anchor:"accelerate.Accelerator.prepare_scheduler.example",$$slots:{default:[R2]},$$scope:{ctx:x}}}),ws=new z({props:{name:"print",anchor:"accelerate.Accelerator.print",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L780"}}),Da=new T({props:{anchor:"accelerate.Accelerator.print.example",$$slots:{default:[G2]},$$scope:{ctx:x}}}),ks=new z({props:{name:"reduce",anchor:"accelerate.Accelerator.reduce",parameters:[{name:"tensor",val:""},{name:"reduction",val:" = 'sum'"}],parametersDescription:[{anchor:"accelerate.Accelerator.reduce.tensor",description:`<strong>tensor</strong> (<code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code>) &#x2014;
The tensors to reduce across all processes.`,name:"tensor"},{anchor:"accelerate.Accelerator.reduce.reduction",description:`<strong>reduction</strong> (<code>str</code>, <em>optional</em>, defaults to &#x201C;sum&#x201D;) &#x2014;
A reduction type, can be one of &#x2018;sum&#x2019;, &#x2018;mean&#x2019;, or &#x2018;none&#x2019;. If &#x2018;none&#x2019;, will not perform any operation.`,name:"reduction"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1623",returnDescription:`
<p>The reduced tensor(s).</p>
`,returnType:`
<p><code>torch.Tensor</code>, or a nested tuple/list/dictionary of <code>torch.Tensor</code></p>
`}}),za=new T({props:{anchor:"accelerate.Accelerator.reduce.example",$$slots:{default:[V2]},$$scope:{ctx:x}}}),js=new z({props:{name:"register_for_checkpointing",anchor:"accelerate.Accelerator.register_for_checkpointing",parameters:[{name:"*objects",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L2279"}}),Ta=new Me({props:{$$slots:{default:[W2]},$$scope:{ctx:x}}}),Oa=new T({props:{anchor:"accelerate.Accelerator.register_for_checkpointing.example",$$slots:{default:[H2]},$$scope:{ctx:x}}}),As=new z({props:{name:"register_load_state_pre_hook",anchor:"accelerate.Accelerator.register_load_state_pre_hook",parameters:[{name:"hook",val:": typing.Callable[..., NoneType]"}],parametersDescription:[{anchor:"accelerate.Accelerator.register_load_state_pre_hook.hook",description:`<strong>hook</strong> (<code>Callable</code>) &#x2014;
A function to be called in <a href="/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.load_state">Accelerator.load_state()</a> before <code>load_checkpoint</code>.`,name:"hook"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L2036",returnDescription:`
<p>a handle that can be used to remove the added hook by calling
<code>handle.remove()</code></p>
`,returnType:`
<p><code>torch.utils.hooks.RemovableHandle</code></p>
`}}),La=new Me({props:{$$slots:{default:[F2]},$$scope:{ctx:x}}}),Es=new z({props:{name:"register_save_state_pre_hook",anchor:"accelerate.Accelerator.register_save_state_pre_hook",parameters:[{name:"hook",val:": typing.Callable[..., NoneType]"}],parametersDescription:[{anchor:"accelerate.Accelerator.register_save_state_pre_hook.hook",description:`<strong>hook</strong> (<code>Callable</code>) &#x2014;
A function to be called in <a href="/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.save_state">Accelerator.save_state()</a> before <code>save_checkpoint</code>.`,name:"hook"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1894",returnDescription:`
<p>a handle that can be used to remove the added hook by calling
<code>handle.remove()</code></p>
`,returnType:`
<p><code>torch.utils.hooks.RemovableHandle</code></p>
`}}),Ia=new Me({props:{$$slots:{default:[Y2]},$$scope:{ctx:x}}}),xs=new z({props:{name:"save",anchor:"accelerate.Accelerator.save",parameters:[{name:"obj",val:""},{name:"f",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.save.obj",description:"<strong>obj</strong> (<code>object</code>) &#x2014; The object to save.",name:"obj"},{anchor:"accelerate.Accelerator.save.f",description:"<strong>f</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014; Where to save the content of <code>obj</code>.",name:"f"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1874"}}),Sa=new T({props:{anchor:"accelerate.Accelerator.save.example",$$slots:{default:[B2]},$$scope:{ctx:x}}}),Ds=new z({props:{name:"save_state",anchor:"accelerate.Accelerator.save_state",parameters:[{name:"output_dir",val:": str = None"},{name:"**save_model_func_kwargs",val:""}],parametersDescription:[{anchor:"accelerate.Accelerator.save_state.output_dir",description:`<strong>output_dir</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The name of the folder to save all relevant weights and states.`,name:"output_dir"},{anchor:"accelerate.Accelerator.save_state.save_model_func_kwargs",description:`<strong>save_model_func_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
Additional keyword arguments for saving model which can be passed to the underlying save function, such
as optional arguments for DeepSpeed&#x2019;s <code>save_checkpoint</code> function.`,name:"save_model_func_kwargs"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1926"}}),Ca=new Me({props:{$$slots:{default:[J2]},$$scope:{ctx:x}}}),qa=new T({props:{anchor:"accelerate.Accelerator.save_state.example",$$slots:{default:[K2]},$$scope:{ctx:x}}}),Ts=new z({props:{name:"skip_first_batches",anchor:"accelerate.Accelerator.skip_first_batches",parameters:[{name:"dataloader",val:""},{name:"num_batches",val:": int = 0"}],parametersDescription:[{anchor:"accelerate.Accelerator.skip_first_batches.dataloader",description:"<strong>dataloader</strong> (<code>torch.utils.data.DataLoader</code>) &#x2014; The data loader in which to skip batches.",name:"dataloader"},{anchor:"accelerate.Accelerator.skip_first_batches.num_batches",description:"<strong>num_batches</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; The number of batches to skip",name:"num_batches"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L2357"}}),Na=new T({props:{anchor:"accelerate.Accelerator.skip_first_batches.example",$$slots:{default:[Q2]},$$scope:{ctx:x}}}),Os=new z({props:{name:"unscale_gradients",anchor:"accelerate.Accelerator.unscale_gradients",parameters:[{name:"optimizer",val:" = None"}],parametersDescription:[{anchor:"accelerate.Accelerator.unscale_gradients.optimizer",description:`<strong>optimizer</strong> (<code>torch.optim.Optimizer</code> or <code>List[torch.optim.Optimizer]</code>, <em>optional</em>) &#x2014;
The optimizer(s) for which to unscale gradients. If not set, will unscale gradients on all optimizers
that were passed to <a href="/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.prepare">prepare()</a>.`,name:"optimizer"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1443"}}),Ga=new T({props:{anchor:"accelerate.Accelerator.unscale_gradients.example",$$slots:{default:[X2]},$$scope:{ctx:x}}}),Ls=new z({props:{name:"unwrap_model",anchor:"accelerate.Accelerator.unwrap_model",parameters:[{name:"model",val:""},{name:"keep_fp32_wrapper",val:": bool = True"}],parametersDescription:[{anchor:"accelerate.Accelerator.unwrap_model.model",description:`<strong>model</strong> (<code>torch.nn.Module</code>) &#x2014;
The model to unwrap.`,name:"model"},{anchor:"accelerate.Accelerator.unwrap_model.keep_fp32_wrapper",description:`<strong>keep_fp32_wrapper</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to not remove the mixed precision hook if it was added.`,name:"keep_fp32_wrapper"}],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1692",returnDescription:`
<p>The unwrapped model.</p>
`,returnType:`
<p><code>torch.nn.Module</code></p>
`}}),Va=new T({props:{anchor:"accelerate.Accelerator.unwrap_model.example",$$slots:{default:[Z2]},$$scope:{ctx:x}}}),Is=new z({props:{name:"wait_for_everyone",anchor:"accelerate.Accelerator.wait_for_everyone",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.16.0/src/accelerate/accelerator.py#L1725"}}),Wa=new T({props:{anchor:"accelerate.Accelerator.wait_for_everyone.example",$$slots:{default:[ew]},$$scope:{ctx:x}}}),{c(){p=c("meta"),u=m(),g=c("h1"),i=c("a"),f=c("span"),v(t.$$.fragment),d=m(),I=c("span"),Ue=s("Accelerator"),ht=m(),J=c("p"),Re=s("The "),q=c("a"),Ws=s("Accelerator"),Hs=s(` is the main class provided by \u{1F917} Accelerate.
It serves at the main entrypoint for the API.`),sr=m(),Ge=c("h2"),gt=c("a"),Jo=c("span"),v(or.$$.fragment),Mi=m(),Ko=c("span"),Ui=s("Quick adaptation of your code"),ip=m(),Fs=c("p"),Ri=s("To quickly adapt your script to work on any kind of setup with \u{1F917} Accelerate just:"),dp=m(),he=c("ol"),Ve=c("li"),Gi=s("Initialize an "),Ys=c("a"),Vi=s("Accelerator"),Wi=s(" object (that we will call "),Qo=c("code"),Hi=s("accelerator"),Fi=s(" throughout this page) as early as possible in your script."),Yi=m(),cr=c("li"),Bi=s("Pass your dataloader(s), model(s), optimizer(s), and scheduler(s) to the "),Bs=c("a"),Ji=s("prepare()"),Ki=s(" method."),Qi=m(),pe=c("li"),Xi=s("Remove all the "),Xo=c("code"),Zi=s(".cuda()"),ed=s(" or "),Zo=c("code"),td=s(".to(device)"),ad=s(" from your code and let the "),ec=c("code"),rd=s("accelerator"),sd=s(" handle the device placement for you."),mp=m(),v(ft.$$.fragment),hp=m(),We=c("ol"),ut=c("li"),od=s("Replace "),tc=c("code"),cd=s("loss.backward()"),ld=s(" in your code with "),ac=c("code"),nd=s("accelerator.backward(loss)"),pd=m(),Js=c("li"),id=s("Gather your predictions and labels before storing them or using them for metric computation using "),Ks=c("a"),dd=s("gather()"),gp=m(),v(_t.$$.fragment),fp=m(),$t=c("p"),md=s(`In most cases this is all that is needed. The next section lists a few more advanced use cases and nice features
you should search for and replace by the corresponding methods of your `),rc=c("code"),hd=s("accelerator"),gd=s(":"),up=m(),He=c("h2"),vt=c("a"),sc=c("span"),v(lr.$$.fragment),fd=m(),oc=c("span"),ud=s("Advanced recommendations"),_p=m(),Fe=c("h3"),bt=c("a"),cc=c("span"),v(nr.$$.fragment),_d=m(),lc=c("span"),$d=s("Printing"),$p=m(),Ye=c("p"),nc=c("code"),vd=s("print"),bd=s(" statements should be replaced by "),Qs=c("a"),wd=s("print()"),yd=s(" to be printed once per process"),vp=m(),v(pr.$$.fragment),bp=m(),Be=c("h3"),wt=c("a"),pc=c("span"),v(ir.$$.fragment),kd=m(),ic=c("span"),jd=s("Executing processes"),wp=m(),Je=c("h4"),yt=c("a"),dc=c("span"),v(dr.$$.fragment),Ad=m(),mc=c("span"),Ed=s("Once on a single server"),yp=m(),kt=c("p"),xd=s("For statements that should be executed once per server, use "),hc=c("code"),Pd=s("is_local_main_process"),Dd=s(":"),kp=m(),v(mr.$$.fragment),jp=m(),jt=c("p"),zd=s("A function can be wrapped using the "),Xs=c("a"),Td=s("on_local_main_process()"),Od=s(` function to achieve the same
behavior on a function\u2019s execution:`),Ap=m(),v(hr.$$.fragment),Ep=m(),Ke=c("h4"),At=c("a"),gc=c("span"),v(gr.$$.fragment),Ld=m(),fc=c("span"),Id=s("Only ever once across all servers"),xp=m(),Et=c("p"),Sd=s("For statements that should only ever be executed once, use "),uc=c("code"),Cd=s("is_main_process"),qd=s(":"),Pp=m(),v(fr.$$.fragment),Dp=m(),xt=c("p"),Nd=s("A function can be wrapped using the "),Zs=c("a"),Md=s("on_main_process()"),Ud=s(` function to achieve the same
behavior on a function\u2019s execution:`),zp=m(),v(ur.$$.fragment),Tp=m(),Qe=c("h4"),Pt=c("a"),_c=c("span"),v(_r.$$.fragment),Rd=m(),$c=c("span"),Gd=s("On specific processes"),Op=m(),eo=c("p"),Vd=s(`If a function should be ran on a specific overall or local process index, there are similar decorators
to achieve this:`),Lp=m(),v($r.$$.fragment),Ip=m(),v(vr.$$.fragment),Sp=m(),Xe=c("h3"),Dt=c("a"),vc=c("span"),v(br.$$.fragment),Wd=m(),bc=c("span"),Hd=s("Synchronicity control"),Cp=m(),zt=c("p"),Fd=s("Use "),to=c("a"),Yd=s("wait_for_everyone()"),Bd=s(" to make sure all processes join that point before continuing. (Useful before a model save for instance)"),qp=m(),Ze=c("h3"),Tt=c("a"),wc=c("span"),v(wr.$$.fragment),Jd=m(),yc=c("span"),Kd=s("Saving and loading"),Np=m(),Ot=c("p"),Qd=s("Use "),ao=c("a"),Xd=s("unwrap_model()"),Zd=s(" before saving to remove all special model wrappers added during the distributed process."),Mp=m(),v(yr.$$.fragment),Up=m(),ge=c("p"),em=s("Use "),ro=c("a"),tm=s("save()"),am=s(" instead of "),kc=c("code"),rm=s("torch.save"),sm=s(":"),Rp=m(),v(kr.$$.fragment),Gp=m(),et=c("h3"),Lt=c("a"),jc=c("span"),v(jr.$$.fragment),om=m(),Ac=c("span"),cm=s("Operations"),Vp=m(),Y=c("p"),lm=s("Use "),It=c("a"),nm=s("clip"),Ec=c("em"),pm=s("grad_norm"),im=s("()"),dm=s(" instead of "),xc=c("code"),mm=s("torch.nn.utils.clip_grad_norm_"),hm=s(" and "),St=c("a"),gm=s("clip"),Pc=c("em"),fm=s("grad_value"),um=s("()"),_m=s(" instead of "),Dc=c("code"),$m=s("torch.nn.utils.clip_grad_value"),Wp=m(),tt=c("h3"),Ct=c("a"),zc=c("span"),v(Ar.$$.fragment),vm=m(),Tc=c("span"),bm=s("Gradient Accumulation"),Hp=m(),qt=c("p"),wm=s("To perform gradient accumulation use "),so=c("a"),ym=s("accumulate()"),km=s(` and specify a gradient_accumulation_steps.
This will also automatically ensure the gradients are synced or unsynced when on
multi-device training, check if the step should actually be performed, and auto-scale the loss:`),Fp=m(),v(Er.$$.fragment),Yp=m(),at=c("h2"),Nt=c("a"),Oc=c("span"),v(xr.$$.fragment),jm=m(),Lc=c("span"),Am=s("Overall API documentation:"),Bp=m(),E=c("div"),v(Pr.$$.fragment),Em=m(),Ic=c("p"),xm=s("Creates an instance of an accelerator for distributed training (on multi-GPU, TPU) or mixed precision training."),Pm=m(),Sc=c("p"),Cc=c("strong"),Dm=s("Available attributes:"),zm=m(),L=c("ul"),Mt=c("li"),qc=c("strong"),Tm=s("device"),Om=s(" ("),Nc=c("code"),Lm=s("torch.device"),Im=s(") \u2014 The device to use."),Sm=m(),Ut=c("li"),Mc=c("strong"),Cm=s("distributed_type"),qm=s(" ("),oo=c("a"),Nm=s("DistributedType"),Mm=s(") \u2014 The distributed training configuration."),Um=m(),Rt=c("li"),Uc=c("strong"),Rm=s("local_process_index"),Gm=s(" ("),Rc=c("code"),Vm=s("int"),Wm=s(") \u2014 The process index on the current machine."),Hm=m(),Gt=c("li"),Gc=c("strong"),Fm=s("mixed_precision"),Ym=s(" ("),Vc=c("code"),Bm=s("str"),Jm=s(") \u2014 The configured mixed precision mode."),Km=m(),Vt=c("li"),Wc=c("strong"),Qm=s("num_processes"),Xm=s(" ("),Hc=c("code"),Zm=s("int"),eh=s(") \u2014 The total number of processes used for training."),th=m(),Wt=c("li"),Fc=c("strong"),ah=s("optimizer_step_was_skipped"),rh=s(" ("),Yc=c("code"),sh=s("bool"),oh=s(`) \u2014 Whether or not the optimizer update was skipped (because of
gradient overflow in mixed precision), in which
case the learning rate should not be changed.`),ch=m(),Ht=c("li"),Bc=c("strong"),lh=s("process_index"),nh=s(" ("),Jc=c("code"),ph=s("int"),ih=s(") \u2014 The overall index of the current process among all processes."),dh=m(),Ft=c("li"),Kc=c("strong"),mh=s("state"),hh=s(" ("),co=c("a"),gh=s("AcceleratorState"),fh=s(") \u2014 The distributed setup state."),uh=m(),Yt=c("li"),Qc=c("strong"),_h=s("sync_gradients"),$h=s(" ("),Xc=c("code"),vh=s("bool"),bh=s(") \u2014 Whether the gradients are currently being synced across all processes."),wh=m(),Bt=c("li"),Zc=c("strong"),yh=s("use_distributed"),kh=s(" ("),el=c("code"),jh=s("bool"),Ah=s(") \u2014 Whether the current configuration is for distributed training."),Eh=m(),fe=c("div"),v(Dr.$$.fragment),xh=m(),tl=c("p"),Ph=s("A context manager that will lightly wrap around and perform gradient accumulation automatically"),Dh=m(),v(Jt.$$.fragment),zh=m(),ue=c("div"),v(zr.$$.fragment),Th=m(),al=c("p"),Oh=s(`Will apply automatic mixed-precision inside the block inside this context manager, if it is enabled. Nothing
different will happen otherwise.`),Lh=m(),v(Kt.$$.fragment),Ih=m(),K=c("div"),v(Tr.$$.fragment),Sh=m(),rt=c("p"),Ch=s("Scales the gradients in accordance to "),rl=c("code"),qh=s("Accelerator.gradient_accumulation_steps"),Nh=s(` and calls the correct
`),sl=c("code"),Mh=s("backward()"),Uh=s(" based on the configuration."),Rh=m(),Or=c("p"),Gh=s("Should be used in lieu of "),ol=c("code"),Vh=s("loss.backward()"),Wh=s("."),Hh=m(),v(Qt.$$.fragment),Fh=m(),_e=c("div"),v(Lr.$$.fragment),Yh=m(),Ir=c("p"),Bh=s("Alias for "),cl=c("code"),Jh=s("Accelerate.free_memory"),Kh=s(`, releases all references to the internal objects stored and call the
garbage collector. You should call this method between two trainings with different models/optimizers.`),Qh=m(),v(Xt.$$.fragment),Xh=m(),$e=c("div"),v(Sr.$$.fragment),Zh=m(),Cr=c("p"),eg=s("Should be used in place of "),ll=c("code"),tg=s("torch.nn.utils.clip_grad_norm_"),ag=s("."),rg=m(),v(Zt.$$.fragment),sg=m(),ve=c("div"),v(qr.$$.fragment),og=m(),Nr=c("p"),cg=s("Should be used in place of "),nl=c("code"),lg=s("torch.nn.utils.clip_grad_value_"),ng=s("."),pg=m(),v(ea.$$.fragment),ig=m(),be=c("div"),v(Mr.$$.fragment),dg=m(),pl=c("p"),mg=s(`Runs any special end training behaviors, such as stopping trackers on the main process only. Should always be
called at the end of your script if using experiment tracking.`),hg=m(),v(ta.$$.fragment),gg=m(),we=c("div"),v(Ur.$$.fragment),fg=m(),il=c("p"),ug=s(`Will release all references to the internal objects stored and call the garbage collector. You should call this
method between two trainings with different models/optimizers.`),_g=m(),v(aa.$$.fragment),$g=m(),Q=c("div"),v(Rr.$$.fragment),vg=m(),Gr=c("p"),bg=s("Gather the values in "),dl=c("em"),wg=s("tensor"),yg=s(` across all processes and concatenate them on the first dimension. Useful to
regroup the predictions from all processes when doing evaluation.`),kg=m(),ml=c("p"),jg=s(`Note:
This gather happens in all processes.`),Ag=m(),v(ra.$$.fragment),Eg=m(),ye=c("div"),v(Vr.$$.fragment),xg=m(),Wr=c("p"),Pg=s("Gathers "),hl=c("code"),Dg=s("tensor"),zg=s(` and potentially drops duplicates in the last batch if on a distributed system. Should be used
for gathering the inputs and targets for metric calculation.`),Tg=m(),v(sa.$$.fragment),Og=m(),ke=c("div"),v(Hr.$$.fragment),Lg=m(),Fr=c("p"),Ig=s("Returns the state dictionary of a model sent through "),lo=c("a"),Sg=s("Accelerator.prepare()"),Cg=s(` potentially without full
precision.`),qg=m(),v(oa.$$.fragment),Ng=m(),je=c("div"),v(Yr.$$.fragment),Mg=m(),ie=c("p"),Ug=s("Returns a "),gl=c("code"),Rg=s("tracker"),Gg=s(" from "),fl=c("code"),Vg=s("self.trackers"),Wg=s(" based on "),ul=c("code"),Hg=s("name"),Fg=s(" on the main process only."),Yg=m(),v(ca.$$.fragment),Bg=m(),Ae=c("div"),v(Br.$$.fragment),Jg=m(),Jr=c("p"),Kg=s("Initializes a run for all trackers stored in "),_l=c("code"),Qg=s("self.log_with"),Xg=s(", potentially with starting configurations"),Zg=m(),v(la.$$.fragment),ef=m(),W=c("div"),v(Kr.$$.fragment),tf=m(),Qr=c("p"),af=s(`A context manager that facilitates distributed training or evaluation on uneven inputs, which acts as a wrapper
around `),$l=c("code"),rf=s("torch.distributed.algorithms.join"),sf=s(`. This is useful when the total batch size does not evenly divide the
length of the dataset.`),of=m(),v(na.$$.fragment),cf=m(),v(pa.$$.fragment),lf=m(),v(ia.$$.fragment),nf=m(),X=c("div"),v(Xr.$$.fragment),pf=m(),vl=c("p"),df=s("Loads the current states of the model, optimizer, scaler, RNG generators, and registered objects."),mf=m(),v(da.$$.fragment),hf=m(),v(ma.$$.fragment),gf=m(),Z=c("div"),v(Zr.$$.fragment),ff=m(),bl=c("p"),uf=s("Lets the local main process go inside a with block."),_f=m(),wl=c("p"),$f=s("The other processes will enter the with block after the main process exits."),vf=m(),v(ha.$$.fragment),bf=m(),Ee=c("div"),v(es.$$.fragment),wf=m(),st=c("p"),yf=s("Logs "),yl=c("code"),kf=s("values"),jf=s(" to all stored trackers in "),kl=c("code"),Af=s("self.trackers"),Ef=s(" on the main process only."),xf=m(),v(ga.$$.fragment),Pf=m(),ee=c("div"),v(ts.$$.fragment),Df=m(),jl=c("p"),zf=s("Lets the main process go first inside a with block."),Tf=m(),Al=c("p"),Of=s("The other processes will enter the with block after the main process exits."),Lf=m(),v(fa.$$.fragment),If=m(),te=c("div"),v(as.$$.fragment),Sf=m(),rs=c("p"),Cf=s(`A context manager to disable gradient synchronizations across DDP processes by calling
`),El=c("code"),qf=s("torch.nn.parallel.DistributedDataParallel.no_sync"),Nf=s("."),Mf=m(),ss=c("p"),Uf=s("If "),xl=c("code"),Rf=s("model"),Gf=s(" is not in DDP, this context manager does nothing"),Vf=m(),v(ua.$$.fragment),Wf=m(),_a=c("div"),v(os.$$.fragment),Hf=m(),Pl=c("p"),Ff=s("A decorator that will run the decorated function on the last process only."),Yf=m(),$a=c("div"),v(cs.$$.fragment),Bf=m(),Dl=c("p"),Jf=s("A decorator that will run the decorated function on the local main process only."),Kf=m(),va=c("div"),v(ls.$$.fragment),Qf=m(),zl=c("p"),Xf=s("A decorator that will run the decorated function on a given local process index only."),Zf=m(),ba=c("div"),v(ns.$$.fragment),eu=m(),Tl=c("p"),tu=s("A decorator that will run the decorated function on the main process only."),au=m(),wa=c("div"),v(ps.$$.fragment),ru=m(),Ol=c("p"),su=s("A decorator that will run the decorated function on a given process index only."),ou=m(),xe=c("div"),v(is.$$.fragment),cu=m(),Ll=c("p"),lu=s(`Recursively pad the tensors in a nested list/tuple/dictionary of tensors from all devices to the same size so
they can safely be gathered.`),nu=m(),v(ya.$$.fragment),pu=m(),ae=c("div"),v(ds.$$.fragment),iu=m(),ms=c("p"),du=s("Prepare all objects passed in "),Il=c("code"),mu=s("args"),hu=s(` for distributed training and mixed precision, then return them in the same
order.`),gu=m(),v(ka.$$.fragment),fu=m(),v(ja.$$.fragment),uu=m(),Pe=c("div"),v(hs.$$.fragment),_u=m(),gs=c("p"),$u=s(`Prepares a PyTorch DataLoader for training in any distributed setup. It is recommended to use
`),no=c("a"),vu=s("Accelerator.prepare()"),bu=s(" instead."),wu=m(),v(Aa.$$.fragment),yu=m(),De=c("div"),v(fs.$$.fragment),ku=m(),us=c("p"),ju=s(`Prepares a PyTorch model for training in any distributed setup. It is recommended to use
`),po=c("a"),Au=s("Accelerator.prepare()"),Eu=s(" instead."),xu=m(),v(Ea.$$.fragment),Pu=m(),ze=c("div"),v(_s.$$.fragment),Du=m(),$s=c("p"),zu=s(`Prepares a PyTorch Optimizer for training in any distributed setup. It is recommended to use
`),io=c("a"),Tu=s("Accelerator.prepare()"),Ou=s(" instead."),Lu=m(),v(xa.$$.fragment),Iu=m(),Te=c("div"),v(vs.$$.fragment),Su=m(),bs=c("p"),Cu=s(`Prepares a PyTorch Scheduler for training in any distributed setup. It is recommended to use
`),mo=c("a"),qu=s("Accelerator.prepare()"),Nu=s(" instead."),Mu=m(),v(Pa.$$.fragment),Uu=m(),Oe=c("div"),v(ws.$$.fragment),Ru=m(),ys=c("p"),Gu=s("Drop in replacement of "),Sl=c("code"),Vu=s("print()"),Wu=s(" to only print once per server."),Hu=m(),v(Da.$$.fragment),Fu=m(),re=c("div"),v(ks.$$.fragment),Yu=m(),ot=c("p"),Bu=s("Reduce the values in "),Cl=c("em"),Ju=s("tensor"),Ku=s(" across all processes based on "),ql=c("em"),Qu=s("reduction"),Xu=s("."),Zu=m(),Nl=c("p"),e_=s(`Note:
All processes get the reduced value.`),t_=m(),v(za.$$.fragment),a_=m(),H=c("div"),v(js.$$.fragment),r_=m(),de=c("p"),s_=s("Makes note of "),Ml=c("code"),o_=s("objects"),c_=s(" and will save or load them in during "),Ul=c("code"),l_=s("save_state"),n_=s(" or "),Rl=c("code"),p_=s("load_state"),i_=s("."),d_=m(),Gl=c("p"),m_=s(`These should be utilized when the state is being loaded or saved in the same script. It is not designed to be
used in different scripts.`),h_=m(),v(Ta.$$.fragment),g_=m(),v(Oa.$$.fragment),f_=m(),M=c("div"),v(As.$$.fragment),u_=m(),ct=c("p"),__=s("Registers a pre hook to be run before "),Vl=c("code"),$_=s("load_checkpoint"),v_=s(" is called in "),ho=c("a"),b_=s("Accelerator.load_state()"),w_=s("."),y_=m(),Wl=c("p"),k_=s("The hook should have the following signature:"),j_=m(),Hl=c("p"),Fl=c("code"),A_=s("hook(models: List[torch.nn.Module], input_dir: str) -> None"),E_=m(),V=c("p"),x_=s("The "),Yl=c("code"),P_=s("models"),D_=s(" argument are the models as saved in the accelerator state under "),Bl=c("code"),z_=s("accelerator._models"),T_=s(`, and the
`),Jl=c("code"),O_=s("input_dir"),L_=s(" argument is the "),Kl=c("code"),I_=s("input_dir"),S_=s(" argument passed to "),go=c("a"),C_=s("Accelerator.load_state()"),q_=s("."),N_=m(),v(La.$$.fragment),M_=m(),U=c("div"),v(Es.$$.fragment),U_=m(),lt=c("p"),R_=s("Registers a pre hook to be run before "),Ql=c("code"),G_=s("save_checkpoint"),V_=s(" is called in "),fo=c("a"),W_=s("Accelerator.save_state()"),H_=s("."),F_=m(),Xl=c("p"),Y_=s("The hook should have the following signature:"),B_=m(),Zl=c("p"),en=c("code"),J_=s("hook(models: List[torch.nn.Module], weights: List[Dict[str, torch.Tensor]], input_dir: str) -> None"),K_=m(),C=c("p"),Q_=s("The "),tn=c("code"),X_=s("models"),Z_=s(" argument are the models as saved in the accelerator state under "),an=c("code"),e$=s("accelerator._models"),t$=s(", "),rn=c("code"),a$=s("weigths"),r$=s(`
argument are the state dicts of the `),sn=c("code"),s$=s("models"),o$=s(", and the "),on=c("code"),c$=s("input_dir"),l$=s(" argument is the "),cn=c("code"),n$=s("input_dir"),p$=s(` argument passed
to `),uo=c("a"),i$=s("Accelerator.load_state()"),d$=s("."),m$=m(),v(Ia.$$.fragment),h$=m(),Le=c("div"),v(xs.$$.fragment),g$=m(),Ps=c("p"),f$=s("Save the object passed to disk once per machine. Use in place of "),ln=c("code"),u$=s("torch.save"),_$=s("."),$$=m(),v(Sa.$$.fragment),v$=m(),R=c("div"),v(Ds.$$.fragment),b$=m(),nn=c("p"),w$=s("Saves the current states of the model, optimizer, scaler, RNG generators, and registered objects to a folder."),y$=m(),N=c("p"),k$=s("If a "),pn=c("code"),j$=s("ProjectConfiguration"),A$=s(" was passed to the "),dn=c("code"),E$=s("Accelerator"),x$=s(" object with "),mn=c("code"),P$=s("automatic_checkpoint_naming"),D$=s(` enabled
then checkpoints will be saved to `),hn=c("code"),z$=s("self.project_dir/checkpoints"),T$=s(`. If the number of current saves is greater
than `),gn=c("code"),O$=s("total_limit"),L$=s(` then the oldest save is deleted. Each checkpoint is saved in seperate folders named
`),fn=c("code"),I$=s("checkpoint_<iteration>"),S$=s("."),C$=m(),zs=c("p"),q$=s("Otherwise they are just saved to "),un=c("code"),N$=s("output_dir"),M$=s("."),U$=m(),v(Ca.$$.fragment),R$=m(),v(qa.$$.fragment),G$=m(),Ie=c("div"),v(Ts.$$.fragment),V$=m(),nt=c("p"),W$=s("Creates a new "),_n=c("code"),H$=s("torch.utils.data.DataLoader"),F$=s(" that will efficiently skip the first "),$n=c("code"),Y$=s("num_batches"),B$=s("."),J$=m(),v(Na.$$.fragment),K$=m(),se=c("div"),v(Os.$$.fragment),Q$=m(),vn=c("p"),X$=s("Unscale the gradients in mixed precision training with AMP. This is a noop in all other settings."),Z$=m(),Ma=c("p"),ev=s("Likely should be called through "),Ua=c("a"),tv=s("Accelerator.clip"),bn=c("em"),av=s("grad_norm"),rv=s("()"),sv=s(" or "),Ra=c("a"),ov=s("Accelerator.clip"),wn=c("em"),cv=s("grad_value"),lv=s("()"),nv=m(),v(Ga.$$.fragment),pv=m(),Se=c("div"),v(Ls.$$.fragment),iv=m(),pt=c("p"),dv=s("Unwraps the "),yn=c("code"),mv=s("model"),hv=s(" from the additional layer possible added by "),_o=c("a"),gv=s("prepare()"),fv=s(`. Useful before saving
the model.`),uv=m(),v(Va.$$.fragment),_v=m(),Ce=c("div"),v(Is.$$.fragment),$v=m(),kn=c("p"),vv=s(`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),bv=m(),v(Wa.$$.fragment),this.h()},l(a){const _=p2('[data-svelte="svelte-1phssyn"]',document.head);p=l(_,"META",{name:!0,content:!0}),_.forEach(r),u=h(a),g=l(a,"H1",{class:!0});var Ss=n(g);i=l(Ss,"A",{id:!0,class:!0,href:!0});var jn=n(i);f=l(jn,"SPAN",{});var An=n(f);b(t.$$.fragment,An),An.forEach(r),jn.forEach(r),d=h(Ss),I=l(Ss,"SPAN",{});var En=n(I);Ue=o(En,"Accelerator"),En.forEach(r),Ss.forEach(r),ht=h(a),J=l(a,"P",{});var Cs=n(J);Re=o(Cs,"The "),q=l(Cs,"A",{href:!0});var xn=n(q);Ws=o(xn,"Accelerator"),xn.forEach(r),Hs=o(Cs,` is the main class provided by \u{1F917} Accelerate.
It serves at the main entrypoint for the API.`),Cs.forEach(r),sr=h(a),Ge=l(a,"H2",{class:!0});var qs=n(Ge);gt=l(qs,"A",{id:!0,class:!0,href:!0});var Pn=n(gt);Jo=l(Pn,"SPAN",{});var Dn=n(Jo);b(or.$$.fragment,Dn),Dn.forEach(r),Pn.forEach(r),Mi=h(qs),Ko=l(qs,"SPAN",{});var zn=n(Ko);Ui=o(zn,"Quick adaptation of your code"),zn.forEach(r),qs.forEach(r),ip=h(a),Fs=l(a,"P",{});var Tn=n(Fs);Ri=o(Tn,"To quickly adapt your script to work on any kind of setup with \u{1F917} Accelerate just:"),Tn.forEach(r),dp=h(a),he=l(a,"OL",{});var it=n(he);Ve=l(it,"LI",{});var dt=n(Ve);Gi=o(dt,"Initialize an "),Ys=l(dt,"A",{href:!0});var On=n(Ys);Vi=o(On,"Accelerator"),On.forEach(r),Wi=o(dt," object (that we will call "),Qo=l(dt,"CODE",{});var Ln=n(Qo);Hi=o(Ln,"accelerator"),Ln.forEach(r),Fi=o(dt," throughout this page) as early as possible in your script."),dt.forEach(r),Yi=h(it),cr=l(it,"LI",{});var Ns=n(cr);Bi=o(Ns,"Pass your dataloader(s), model(s), optimizer(s), and scheduler(s) to the "),Bs=l(Ns,"A",{href:!0});var In=n(Bs);Ji=o(In,"prepare()"),In.forEach(r),Ki=o(Ns," method."),Ns.forEach(r),Qi=h(it),pe=l(it,"LI",{});var me=n(pe);Xi=o(me,"Remove all the "),Xo=l(me,"CODE",{});var Sn=n(Xo);Zi=o(Sn,".cuda()"),Sn.forEach(r),ed=o(me," or "),Zo=l(me,"CODE",{});var Cn=n(Zo);td=o(Cn,".to(device)"),Cn.forEach(r),ad=o(me," from your code and let the "),ec=l(me,"CODE",{});var qn=n(ec);rd=o(qn,"accelerator"),qn.forEach(r),sd=o(me," handle the device placement for you."),me.forEach(r),it.forEach(r),mp=h(a),b(ft.$$.fragment,a),hp=h(a),We=l(a,"OL",{start:!0});var Ms=n(We);ut=l(Ms,"LI",{});var Ha=n(ut);od=o(Ha,"Replace "),tc=l(Ha,"CODE",{});var Nn=n(tc);cd=o(Nn,"loss.backward()"),Nn.forEach(r),ld=o(Ha," in your code with "),ac=l(Ha,"CODE",{});var Mn=n(ac);nd=o(Mn,"accelerator.backward(loss)"),Mn.forEach(r),Ha.forEach(r),pd=h(Ms),Js=l(Ms,"LI",{});var $o=n(Js);id=o($o,"Gather your predictions and labels before storing them or using them for metric computation using "),Ks=l($o,"A",{href:!0});var Un=n(Ks);dd=o(Un,"gather()"),Un.forEach(r),$o.forEach(r),Ms.forEach(r),gp=h(a),b(_t.$$.fragment,a),fp=h(a),$t=l(a,"P",{});var Us=n($t);md=o(Us,`In most cases this is all that is needed. The next section lists a few more advanced use cases and nice features
you should search for and replace by the corresponding methods of your `),rc=l(Us,"CODE",{});var Rn=n(rc);hd=o(Rn,"accelerator"),Rn.forEach(r),gd=o(Us,":"),Us.forEach(r),up=h(a),He=l(a,"H2",{class:!0});var Rs=n(He);vt=l(Rs,"A",{id:!0,class:!0,href:!0});var Gn=n(vt);sc=l(Gn,"SPAN",{});var Vn=n(sc);b(lr.$$.fragment,Vn),Vn.forEach(r),Gn.forEach(r),fd=h(Rs),oc=l(Rs,"SPAN",{});var Wn=n(oc);ud=o(Wn,"Advanced recommendations"),Wn.forEach(r),Rs.forEach(r),_p=h(a),Fe=l(a,"H3",{class:!0});var Gs=n(Fe);bt=l(Gs,"A",{id:!0,class:!0,href:!0});var Hn=n(bt);cc=l(Hn,"SPAN",{});var Fn=n(cc);b(nr.$$.fragment,Fn),Fn.forEach(r),Hn.forEach(r),_d=h(Gs),lc=l(Gs,"SPAN",{});var Yn=n(lc);$d=o(Yn,"Printing"),Yn.forEach(r),Gs.forEach(r),$p=h(a),Ye=l(a,"P",{});var Fa=n(Ye);nc=l(Fa,"CODE",{});var Bn=n(nc);vd=o(Bn,"print"),Bn.forEach(r),bd=o(Fa," statements should be replaced by "),Qs=l(Fa,"A",{href:!0});var Jn=n(Qs);wd=o(Jn,"print()"),Jn.forEach(r),yd=o(Fa," to be printed once per process"),Fa.forEach(r),vp=h(a),b(pr.$$.fragment,a),bp=h(a),Be=l(a,"H3",{class:!0});var Vs=n(Be);wt=l(Vs,"A",{id:!0,class:!0,href:!0});var Kn=n(wt);pc=l(Kn,"SPAN",{});var Qn=n(pc);b(ir.$$.fragment,Qn),Qn.forEach(r),Kn.forEach(r),kd=h(Vs),ic=l(Vs,"SPAN",{});var Xn=n(ic);jd=o(Xn,"Executing processes"),Xn.forEach(r),Vs.forEach(r),wp=h(a),Je=l(a,"H4",{class:!0});var Kp=n(Je);yt=l(Kp,"A",{id:!0,class:!0,href:!0});var wv=n(yt);dc=l(wv,"SPAN",{});var yv=n(dc);b(dr.$$.fragment,yv),yv.forEach(r),wv.forEach(r),Ad=h(Kp),mc=l(Kp,"SPAN",{});var kv=n(mc);Ed=o(kv,"Once on a single server"),kv.forEach(r),Kp.forEach(r),yp=h(a),kt=l(a,"P",{});var Qp=n(kt);xd=o(Qp,"For statements that should be executed once per server, use "),hc=l(Qp,"CODE",{});var jv=n(hc);Pd=o(jv,"is_local_main_process"),jv.forEach(r),Dd=o(Qp,":"),Qp.forEach(r),kp=h(a),b(mr.$$.fragment,a),jp=h(a),jt=l(a,"P",{});var Xp=n(jt);zd=o(Xp,"A function can be wrapped using the "),Xs=l(Xp,"A",{href:!0});var Av=n(Xs);Td=o(Av,"on_local_main_process()"),Av.forEach(r),Od=o(Xp,` function to achieve the same
behavior on a function\u2019s execution:`),Xp.forEach(r),Ap=h(a),b(hr.$$.fragment,a),Ep=h(a),Ke=l(a,"H4",{class:!0});var Zp=n(Ke);At=l(Zp,"A",{id:!0,class:!0,href:!0});var Ev=n(At);gc=l(Ev,"SPAN",{});var xv=n(gc);b(gr.$$.fragment,xv),xv.forEach(r),Ev.forEach(r),Ld=h(Zp),fc=l(Zp,"SPAN",{});var Pv=n(fc);Id=o(Pv,"Only ever once across all servers"),Pv.forEach(r),Zp.forEach(r),xp=h(a),Et=l(a,"P",{});var ei=n(Et);Sd=o(ei,"For statements that should only ever be executed once, use "),uc=l(ei,"CODE",{});var Dv=n(uc);Cd=o(Dv,"is_main_process"),Dv.forEach(r),qd=o(ei,":"),ei.forEach(r),Pp=h(a),b(fr.$$.fragment,a),Dp=h(a),xt=l(a,"P",{});var ti=n(xt);Nd=o(ti,"A function can be wrapped using the "),Zs=l(ti,"A",{href:!0});var zv=n(Zs);Md=o(zv,"on_main_process()"),zv.forEach(r),Ud=o(ti,` function to achieve the same
behavior on a function\u2019s execution:`),ti.forEach(r),zp=h(a),b(ur.$$.fragment,a),Tp=h(a),Qe=l(a,"H4",{class:!0});var ai=n(Qe);Pt=l(ai,"A",{id:!0,class:!0,href:!0});var Tv=n(Pt);_c=l(Tv,"SPAN",{});var Ov=n(_c);b(_r.$$.fragment,Ov),Ov.forEach(r),Tv.forEach(r),Rd=h(ai),$c=l(ai,"SPAN",{});var Lv=n($c);Gd=o(Lv,"On specific processes"),Lv.forEach(r),ai.forEach(r),Op=h(a),eo=l(a,"P",{});var Iv=n(eo);Vd=o(Iv,`If a function should be ran on a specific overall or local process index, there are similar decorators
to achieve this:`),Iv.forEach(r),Lp=h(a),b($r.$$.fragment,a),Ip=h(a),b(vr.$$.fragment,a),Sp=h(a),Xe=l(a,"H3",{class:!0});var ri=n(Xe);Dt=l(ri,"A",{id:!0,class:!0,href:!0});var Sv=n(Dt);vc=l(Sv,"SPAN",{});var Cv=n(vc);b(br.$$.fragment,Cv),Cv.forEach(r),Sv.forEach(r),Wd=h(ri),bc=l(ri,"SPAN",{});var qv=n(bc);Hd=o(qv,"Synchronicity control"),qv.forEach(r),ri.forEach(r),Cp=h(a),zt=l(a,"P",{});var si=n(zt);Fd=o(si,"Use "),to=l(si,"A",{href:!0});var Nv=n(to);Yd=o(Nv,"wait_for_everyone()"),Nv.forEach(r),Bd=o(si," to make sure all processes join that point before continuing. (Useful before a model save for instance)"),si.forEach(r),qp=h(a),Ze=l(a,"H3",{class:!0});var oi=n(Ze);Tt=l(oi,"A",{id:!0,class:!0,href:!0});var Mv=n(Tt);wc=l(Mv,"SPAN",{});var Uv=n(wc);b(wr.$$.fragment,Uv),Uv.forEach(r),Mv.forEach(r),Jd=h(oi),yc=l(oi,"SPAN",{});var Rv=n(yc);Kd=o(Rv,"Saving and loading"),Rv.forEach(r),oi.forEach(r),Np=h(a),Ot=l(a,"P",{});var ci=n(Ot);Qd=o(ci,"Use "),ao=l(ci,"A",{href:!0});var Gv=n(ao);Xd=o(Gv,"unwrap_model()"),Gv.forEach(r),Zd=o(ci," before saving to remove all special model wrappers added during the distributed process."),ci.forEach(r),Mp=h(a),b(yr.$$.fragment,a),Up=h(a),ge=l(a,"P",{});var vo=n(ge);em=o(vo,"Use "),ro=l(vo,"A",{href:!0});var Vv=n(ro);tm=o(Vv,"save()"),Vv.forEach(r),am=o(vo," instead of "),kc=l(vo,"CODE",{});var Wv=n(kc);rm=o(Wv,"torch.save"),Wv.forEach(r),sm=o(vo,":"),vo.forEach(r),Rp=h(a),b(kr.$$.fragment,a),Gp=h(a),et=l(a,"H3",{class:!0});var li=n(et);Lt=l(li,"A",{id:!0,class:!0,href:!0});var Hv=n(Lt);jc=l(Hv,"SPAN",{});var Fv=n(jc);b(jr.$$.fragment,Fv),Fv.forEach(r),Hv.forEach(r),om=h(li),Ac=l(li,"SPAN",{});var Yv=n(Ac);cm=o(Yv,"Operations"),Yv.forEach(r),li.forEach(r),Vp=h(a),Y=l(a,"P",{});var mt=n(Y);lm=o(mt,"Use "),It=l(mt,"A",{href:!0});var ni=n(It);nm=o(ni,"clip"),Ec=l(ni,"EM",{});var Bv=n(Ec);pm=o(Bv,"grad_norm"),Bv.forEach(r),im=o(ni,"()"),ni.forEach(r),dm=o(mt," instead of "),xc=l(mt,"CODE",{});var Jv=n(xc);mm=o(Jv,"torch.nn.utils.clip_grad_norm_"),Jv.forEach(r),hm=o(mt," and "),St=l(mt,"A",{href:!0});var pi=n(St);gm=o(pi,"clip"),Pc=l(pi,"EM",{});var Kv=n(Pc);fm=o(Kv,"grad_value"),Kv.forEach(r),um=o(pi,"()"),pi.forEach(r),_m=o(mt," instead of "),Dc=l(mt,"CODE",{});var Qv=n(Dc);$m=o(Qv,"torch.nn.utils.clip_grad_value"),Qv.forEach(r),mt.forEach(r),Wp=h(a),tt=l(a,"H3",{class:!0});var ii=n(tt);Ct=l(ii,"A",{id:!0,class:!0,href:!0});var Xv=n(Ct);zc=l(Xv,"SPAN",{});var Zv=n(zc);b(Ar.$$.fragment,Zv),Zv.forEach(r),Xv.forEach(r),vm=h(ii),Tc=l(ii,"SPAN",{});var eb=n(Tc);bm=o(eb,"Gradient Accumulation"),eb.forEach(r),ii.forEach(r),Hp=h(a),qt=l(a,"P",{});var di=n(qt);wm=o(di,"To perform gradient accumulation use "),so=l(di,"A",{href:!0});var tb=n(so);ym=o(tb,"accumulate()"),tb.forEach(r),km=o(di,` and specify a gradient_accumulation_steps.
This will also automatically ensure the gradients are synced or unsynced when on
multi-device training, check if the step should actually be performed, and auto-scale the loss:`),di.forEach(r),Fp=h(a),b(Er.$$.fragment,a),Yp=h(a),at=l(a,"H2",{class:!0});var mi=n(at);Nt=l(mi,"A",{id:!0,class:!0,href:!0});var ab=n(Nt);Oc=l(ab,"SPAN",{});var rb=n(Oc);b(xr.$$.fragment,rb),rb.forEach(r),ab.forEach(r),jm=h(mi),Lc=l(mi,"SPAN",{});var sb=n(Lc);Am=o(sb,"Overall API documentation:"),sb.forEach(r),mi.forEach(r),Bp=h(a),E=l(a,"DIV",{class:!0});var P=n(E);b(Pr.$$.fragment,P),Em=h(P),Ic=l(P,"P",{});var ob=n(Ic);xm=o(ob,"Creates an instance of an accelerator for distributed training (on multi-GPU, TPU) or mixed precision training."),ob.forEach(r),Pm=h(P),Sc=l(P,"P",{});var cb=n(Sc);Cc=l(cb,"STRONG",{});var lb=n(Cc);Dm=o(lb,"Available attributes:"),lb.forEach(r),cb.forEach(r),zm=h(P),L=l(P,"UL",{});var S=n(L);Mt=l(S,"LI",{});var Zn=n(Mt);qc=l(Zn,"STRONG",{});var nb=n(qc);Tm=o(nb,"device"),nb.forEach(r),Om=o(Zn," ("),Nc=l(Zn,"CODE",{});var pb=n(Nc);Lm=o(pb,"torch.device"),pb.forEach(r),Im=o(Zn,") \u2014 The device to use."),Zn.forEach(r),Sm=h(S),Ut=l(S,"LI",{});var ep=n(Ut);Mc=l(ep,"STRONG",{});var ib=n(Mc);Cm=o(ib,"distributed_type"),ib.forEach(r),qm=o(ep," ("),oo=l(ep,"A",{href:!0});var db=n(oo);Nm=o(db,"DistributedType"),db.forEach(r),Mm=o(ep,") \u2014 The distributed training configuration."),ep.forEach(r),Um=h(S),Rt=l(S,"LI",{});var tp=n(Rt);Uc=l(tp,"STRONG",{});var mb=n(Uc);Rm=o(mb,"local_process_index"),mb.forEach(r),Gm=o(tp," ("),Rc=l(tp,"CODE",{});var hb=n(Rc);Vm=o(hb,"int"),hb.forEach(r),Wm=o(tp,") \u2014 The process index on the current machine."),tp.forEach(r),Hm=h(S),Gt=l(S,"LI",{});var ap=n(Gt);Gc=l(ap,"STRONG",{});var gb=n(Gc);Fm=o(gb,"mixed_precision"),gb.forEach(r),Ym=o(ap," ("),Vc=l(ap,"CODE",{});var fb=n(Vc);Bm=o(fb,"str"),fb.forEach(r),Jm=o(ap,") \u2014 The configured mixed precision mode."),ap.forEach(r),Km=h(S),Vt=l(S,"LI",{});var rp=n(Vt);Wc=l(rp,"STRONG",{});var ub=n(Wc);Qm=o(ub,"num_processes"),ub.forEach(r),Xm=o(rp," ("),Hc=l(rp,"CODE",{});var _b=n(Hc);Zm=o(_b,"int"),_b.forEach(r),eh=o(rp,") \u2014 The total number of processes used for training."),rp.forEach(r),th=h(S),Wt=l(S,"LI",{});var sp=n(Wt);Fc=l(sp,"STRONG",{});var $b=n(Fc);ah=o($b,"optimizer_step_was_skipped"),$b.forEach(r),rh=o(sp," ("),Yc=l(sp,"CODE",{});var vb=n(Yc);sh=o(vb,"bool"),vb.forEach(r),oh=o(sp,`) \u2014 Whether or not the optimizer update was skipped (because of
gradient overflow in mixed precision), in which
case the learning rate should not be changed.`),sp.forEach(r),ch=h(S),Ht=l(S,"LI",{});var op=n(Ht);Bc=l(op,"STRONG",{});var bb=n(Bc);lh=o(bb,"process_index"),bb.forEach(r),nh=o(op," ("),Jc=l(op,"CODE",{});var wb=n(Jc);ph=o(wb,"int"),wb.forEach(r),ih=o(op,") \u2014 The overall index of the current process among all processes."),op.forEach(r),dh=h(S),Ft=l(S,"LI",{});var cp=n(Ft);Kc=l(cp,"STRONG",{});var yb=n(Kc);mh=o(yb,"state"),yb.forEach(r),hh=o(cp," ("),co=l(cp,"A",{href:!0});var kb=n(co);gh=o(kb,"AcceleratorState"),kb.forEach(r),fh=o(cp,") \u2014 The distributed setup state."),cp.forEach(r),uh=h(S),Yt=l(S,"LI",{});var lp=n(Yt);Qc=l(lp,"STRONG",{});var jb=n(Qc);_h=o(jb,"sync_gradients"),jb.forEach(r),$h=o(lp," ("),Xc=l(lp,"CODE",{});var Ab=n(Xc);vh=o(Ab,"bool"),Ab.forEach(r),bh=o(lp,") \u2014 Whether the gradients are currently being synced across all processes."),lp.forEach(r),wh=h(S),Bt=l(S,"LI",{});var np=n(Bt);Zc=l(np,"STRONG",{});var Eb=n(Zc);yh=o(Eb,"use_distributed"),Eb.forEach(r),kh=o(np," ("),el=l(np,"CODE",{});var xb=n(el);jh=o(xb,"bool"),xb.forEach(r),Ah=o(np,") \u2014 Whether the current configuration is for distributed training."),np.forEach(r),S.forEach(r),Eh=h(P),fe=l(P,"DIV",{class:!0});var bo=n(fe);b(Dr.$$.fragment,bo),xh=h(bo),tl=l(bo,"P",{});var Pb=n(tl);Ph=o(Pb,"A context manager that will lightly wrap around and perform gradient accumulation automatically"),Pb.forEach(r),Dh=h(bo),b(Jt.$$.fragment,bo),bo.forEach(r),zh=h(P),ue=l(P,"DIV",{class:!0});var wo=n(ue);b(zr.$$.fragment,wo),Th=h(wo),al=l(wo,"P",{});var Db=n(al);Oh=o(Db,`Will apply automatic mixed-precision inside the block inside this context manager, if it is enabled. Nothing
different will happen otherwise.`),Db.forEach(r),Lh=h(wo),b(Kt.$$.fragment,wo),wo.forEach(r),Ih=h(P),K=l(P,"DIV",{class:!0});var Ya=n(K);b(Tr.$$.fragment,Ya),Sh=h(Ya),rt=l(Ya,"P",{});var yo=n(rt);Ch=o(yo,"Scales the gradients in accordance to "),rl=l(yo,"CODE",{});var zb=n(rl);qh=o(zb,"Accelerator.gradient_accumulation_steps"),zb.forEach(r),Nh=o(yo,` and calls the correct
`),sl=l(yo,"CODE",{});var Tb=n(sl);Mh=o(Tb,"backward()"),Tb.forEach(r),Uh=o(yo," based on the configuration."),yo.forEach(r),Rh=h(Ya),Or=l(Ya,"P",{});var hi=n(Or);Gh=o(hi,"Should be used in lieu of "),ol=l(hi,"CODE",{});var Ob=n(ol);Vh=o(Ob,"loss.backward()"),Ob.forEach(r),Wh=o(hi,"."),hi.forEach(r),Hh=h(Ya),b(Qt.$$.fragment,Ya),Ya.forEach(r),Fh=h(P),_e=l(P,"DIV",{class:!0});var ko=n(_e);b(Lr.$$.fragment,ko),Yh=h(ko),Ir=l(ko,"P",{});var gi=n(Ir);Bh=o(gi,"Alias for "),cl=l(gi,"CODE",{});var Lb=n(cl);Jh=o(Lb,"Accelerate.free_memory"),Lb.forEach(r),Kh=o(gi,`, releases all references to the internal objects stored and call the
garbage collector. You should call this method between two trainings with different models/optimizers.`),gi.forEach(r),Qh=h(ko),b(Xt.$$.fragment,ko),ko.forEach(r),Xh=h(P),$e=l(P,"DIV",{class:!0});var jo=n($e);b(Sr.$$.fragment,jo),Zh=h(jo),Cr=l(jo,"P",{});var fi=n(Cr);eg=o(fi,"Should be used in place of "),ll=l(fi,"CODE",{});var Ib=n(ll);tg=o(Ib,"torch.nn.utils.clip_grad_norm_"),Ib.forEach(r),ag=o(fi,"."),fi.forEach(r),rg=h(jo),b(Zt.$$.fragment,jo),jo.forEach(r),sg=h(P),ve=l(P,"DIV",{class:!0});var Ao=n(ve);b(qr.$$.fragment,Ao),og=h(Ao),Nr=l(Ao,"P",{});var ui=n(Nr);cg=o(ui,"Should be used in place of "),nl=l(ui,"CODE",{});var Sb=n(nl);lg=o(Sb,"torch.nn.utils.clip_grad_value_"),Sb.forEach(r),ng=o(ui,"."),ui.forEach(r),pg=h(Ao),b(ea.$$.fragment,Ao),Ao.forEach(r),ig=h(P),be=l(P,"DIV",{class:!0});var Eo=n(be);b(Mr.$$.fragment,Eo),dg=h(Eo),pl=l(Eo,"P",{});var Cb=n(pl);mg=o(Cb,`Runs any special end training behaviors, such as stopping trackers on the main process only. Should always be
called at the end of your script if using experiment tracking.`),Cb.forEach(r),hg=h(Eo),b(ta.$$.fragment,Eo),Eo.forEach(r),gg=h(P),we=l(P,"DIV",{class:!0});var xo=n(we);b(Ur.$$.fragment,xo),fg=h(xo),il=l(xo,"P",{});var qb=n(il);ug=o(qb,`Will release all references to the internal objects stored and call the garbage collector. You should call this
method between two trainings with different models/optimizers.`),qb.forEach(r),_g=h(xo),b(aa.$$.fragment,xo),xo.forEach(r),$g=h(P),Q=l(P,"DIV",{class:!0});var Ba=n(Q);b(Rr.$$.fragment,Ba),vg=h(Ba),Gr=l(Ba,"P",{});var _i=n(Gr);bg=o(_i,"Gather the values in "),dl=l(_i,"EM",{});var Nb=n(dl);wg=o(Nb,"tensor"),Nb.forEach(r),yg=o(_i,` across all processes and concatenate them on the first dimension. Useful to
regroup the predictions from all processes when doing evaluation.`),_i.forEach(r),kg=h(Ba),ml=l(Ba,"P",{});var Mb=n(ml);jg=o(Mb,`Note:
This gather happens in all processes.`),Mb.forEach(r),Ag=h(Ba),b(ra.$$.fragment,Ba),Ba.forEach(r),Eg=h(P),ye=l(P,"DIV",{class:!0});var Po=n(ye);b(Vr.$$.fragment,Po),xg=h(Po),Wr=l(Po,"P",{});var $i=n(Wr);Pg=o($i,"Gathers "),hl=l($i,"CODE",{});var Ub=n(hl);Dg=o(Ub,"tensor"),Ub.forEach(r),zg=o($i,` and potentially drops duplicates in the last batch if on a distributed system. Should be used
for gathering the inputs and targets for metric calculation.`),$i.forEach(r),Tg=h(Po),b(sa.$$.fragment,Po),Po.forEach(r),Og=h(P),ke=l(P,"DIV",{class:!0});var Do=n(ke);b(Hr.$$.fragment,Do),Lg=h(Do),Fr=l(Do,"P",{});var vi=n(Fr);Ig=o(vi,"Returns the state dictionary of a model sent through "),lo=l(vi,"A",{href:!0});var Rb=n(lo);Sg=o(Rb,"Accelerator.prepare()"),Rb.forEach(r),Cg=o(vi,` potentially without full
precision.`),vi.forEach(r),qg=h(Do),b(oa.$$.fragment,Do),Do.forEach(r),Ng=h(P),je=l(P,"DIV",{class:!0});var zo=n(je);b(Yr.$$.fragment,zo),Mg=h(zo),ie=l(zo,"P",{});var Ja=n(ie);Ug=o(Ja,"Returns a "),gl=l(Ja,"CODE",{});var Gb=n(gl);Rg=o(Gb,"tracker"),Gb.forEach(r),Gg=o(Ja," from "),fl=l(Ja,"CODE",{});var Vb=n(fl);Vg=o(Vb,"self.trackers"),Vb.forEach(r),Wg=o(Ja," based on "),ul=l(Ja,"CODE",{});var Wb=n(ul);Hg=o(Wb,"name"),Wb.forEach(r),Fg=o(Ja," on the main process only."),Ja.forEach(r),Yg=h(zo),b(ca.$$.fragment,zo),zo.forEach(r),Bg=h(P),Ae=l(P,"DIV",{class:!0});var To=n(Ae);b(Br.$$.fragment,To),Jg=h(To),Jr=l(To,"P",{});var bi=n(Jr);Kg=o(bi,"Initializes a run for all trackers stored in "),_l=l(bi,"CODE",{});var Hb=n(_l);Qg=o(Hb,"self.log_with"),Hb.forEach(r),Xg=o(bi,", potentially with starting configurations"),bi.forEach(r),Zg=h(To),b(la.$$.fragment,To),To.forEach(r),ef=h(P),W=l(P,"DIV",{class:!0});var qe=n(W);b(Kr.$$.fragment,qe),tf=h(qe),Qr=l(qe,"P",{});var wi=n(Qr);af=o(wi,`A context manager that facilitates distributed training or evaluation on uneven inputs, which acts as a wrapper
around `),$l=l(wi,"CODE",{});var Fb=n($l);rf=o(Fb,"torch.distributed.algorithms.join"),Fb.forEach(r),sf=o(wi,`. This is useful when the total batch size does not evenly divide the
length of the dataset.`),wi.forEach(r),of=h(qe),b(na.$$.fragment,qe),cf=h(qe),b(pa.$$.fragment,qe),lf=h(qe),b(ia.$$.fragment,qe),qe.forEach(r),nf=h(P),X=l(P,"DIV",{class:!0});var Ka=n(X);b(Xr.$$.fragment,Ka),pf=h(Ka),vl=l(Ka,"P",{});var Yb=n(vl);df=o(Yb,"Loads the current states of the model, optimizer, scaler, RNG generators, and registered objects."),Yb.forEach(r),mf=h(Ka),b(da.$$.fragment,Ka),hf=h(Ka),b(ma.$$.fragment,Ka),Ka.forEach(r),gf=h(P),Z=l(P,"DIV",{class:!0});var Qa=n(Z);b(Zr.$$.fragment,Qa),ff=h(Qa),bl=l(Qa,"P",{});var Bb=n(bl);uf=o(Bb,"Lets the local main process go inside a with block."),Bb.forEach(r),_f=h(Qa),wl=l(Qa,"P",{});var Jb=n(wl);$f=o(Jb,"The other processes will enter the with block after the main process exits."),Jb.forEach(r),vf=h(Qa),b(ha.$$.fragment,Qa),Qa.forEach(r),bf=h(P),Ee=l(P,"DIV",{class:!0});var Oo=n(Ee);b(es.$$.fragment,Oo),wf=h(Oo),st=l(Oo,"P",{});var Lo=n(st);yf=o(Lo,"Logs "),yl=l(Lo,"CODE",{});var Kb=n(yl);kf=o(Kb,"values"),Kb.forEach(r),jf=o(Lo," to all stored trackers in "),kl=l(Lo,"CODE",{});var Qb=n(kl);Af=o(Qb,"self.trackers"),Qb.forEach(r),Ef=o(Lo," on the main process only."),Lo.forEach(r),xf=h(Oo),b(ga.$$.fragment,Oo),Oo.forEach(r),Pf=h(P),ee=l(P,"DIV",{class:!0});var Xa=n(ee);b(ts.$$.fragment,Xa),Df=h(Xa),jl=l(Xa,"P",{});var Xb=n(jl);zf=o(Xb,"Lets the main process go first inside a with block."),Xb.forEach(r),Tf=h(Xa),Al=l(Xa,"P",{});var Zb=n(Al);Of=o(Zb,"The other processes will enter the with block after the main process exits."),Zb.forEach(r),Lf=h(Xa),b(fa.$$.fragment,Xa),Xa.forEach(r),If=h(P),te=l(P,"DIV",{class:!0});var Za=n(te);b(as.$$.fragment,Za),Sf=h(Za),rs=l(Za,"P",{});var yi=n(rs);Cf=o(yi,`A context manager to disable gradient synchronizations across DDP processes by calling
`),El=l(yi,"CODE",{});var e1=n(El);qf=o(e1,"torch.nn.parallel.DistributedDataParallel.no_sync"),e1.forEach(r),Nf=o(yi,"."),yi.forEach(r),Mf=h(Za),ss=l(Za,"P",{});var ki=n(ss);Uf=o(ki,"If "),xl=l(ki,"CODE",{});var t1=n(xl);Rf=o(t1,"model"),t1.forEach(r),Gf=o(ki," is not in DDP, this context manager does nothing"),ki.forEach(r),Vf=h(Za),b(ua.$$.fragment,Za),Za.forEach(r),Wf=h(P),_a=l(P,"DIV",{class:!0});var ji=n(_a);b(os.$$.fragment,ji),Hf=h(ji),Pl=l(ji,"P",{});var a1=n(Pl);Ff=o(a1,"A decorator that will run the decorated function on the last process only."),a1.forEach(r),ji.forEach(r),Yf=h(P),$a=l(P,"DIV",{class:!0});var Ai=n($a);b(cs.$$.fragment,Ai),Bf=h(Ai),Dl=l(Ai,"P",{});var r1=n(Dl);Jf=o(r1,"A decorator that will run the decorated function on the local main process only."),r1.forEach(r),Ai.forEach(r),Kf=h(P),va=l(P,"DIV",{class:!0});var Ei=n(va);b(ls.$$.fragment,Ei),Qf=h(Ei),zl=l(Ei,"P",{});var s1=n(zl);Xf=o(s1,"A decorator that will run the decorated function on a given local process index only."),s1.forEach(r),Ei.forEach(r),Zf=h(P),ba=l(P,"DIV",{class:!0});var xi=n(ba);b(ns.$$.fragment,xi),eu=h(xi),Tl=l(xi,"P",{});var o1=n(Tl);tu=o(o1,"A decorator that will run the decorated function on the main process only."),o1.forEach(r),xi.forEach(r),au=h(P),wa=l(P,"DIV",{class:!0});var Pi=n(wa);b(ps.$$.fragment,Pi),ru=h(Pi),Ol=l(Pi,"P",{});var c1=n(Ol);su=o(c1,"A decorator that will run the decorated function on a given process index only."),c1.forEach(r),Pi.forEach(r),ou=h(P),xe=l(P,"DIV",{class:!0});var Io=n(xe);b(is.$$.fragment,Io),cu=h(Io),Ll=l(Io,"P",{});var l1=n(Ll);lu=o(l1,`Recursively pad the tensors in a nested list/tuple/dictionary of tensors from all devices to the same size so
they can safely be gathered.`),l1.forEach(r),nu=h(Io),b(ya.$$.fragment,Io),Io.forEach(r),pu=h(P),ae=l(P,"DIV",{class:!0});var er=n(ae);b(ds.$$.fragment,er),iu=h(er),ms=l(er,"P",{});var Di=n(ms);du=o(Di,"Prepare all objects passed in "),Il=l(Di,"CODE",{});var n1=n(Il);mu=o(n1,"args"),n1.forEach(r),hu=o(Di,` for distributed training and mixed precision, then return them in the same
order.`),Di.forEach(r),gu=h(er),b(ka.$$.fragment,er),fu=h(er),b(ja.$$.fragment,er),er.forEach(r),uu=h(P),Pe=l(P,"DIV",{class:!0});var So=n(Pe);b(hs.$$.fragment,So),_u=h(So),gs=l(So,"P",{});var zi=n(gs);$u=o(zi,`Prepares a PyTorch DataLoader for training in any distributed setup. It is recommended to use
`),no=l(zi,"A",{href:!0});var p1=n(no);vu=o(p1,"Accelerator.prepare()"),p1.forEach(r),bu=o(zi," instead."),zi.forEach(r),wu=h(So),b(Aa.$$.fragment,So),So.forEach(r),yu=h(P),De=l(P,"DIV",{class:!0});var Co=n(De);b(fs.$$.fragment,Co),ku=h(Co),us=l(Co,"P",{});var Ti=n(us);ju=o(Ti,`Prepares a PyTorch model for training in any distributed setup. It is recommended to use
`),po=l(Ti,"A",{href:!0});var i1=n(po);Au=o(i1,"Accelerator.prepare()"),i1.forEach(r),Eu=o(Ti," instead."),Ti.forEach(r),xu=h(Co),b(Ea.$$.fragment,Co),Co.forEach(r),Pu=h(P),ze=l(P,"DIV",{class:!0});var qo=n(ze);b(_s.$$.fragment,qo),Du=h(qo),$s=l(qo,"P",{});var Oi=n($s);zu=o(Oi,`Prepares a PyTorch Optimizer for training in any distributed setup. It is recommended to use
`),io=l(Oi,"A",{href:!0});var d1=n(io);Tu=o(d1,"Accelerator.prepare()"),d1.forEach(r),Ou=o(Oi," instead."),Oi.forEach(r),Lu=h(qo),b(xa.$$.fragment,qo),qo.forEach(r),Iu=h(P),Te=l(P,"DIV",{class:!0});var No=n(Te);b(vs.$$.fragment,No),Su=h(No),bs=l(No,"P",{});var Li=n(bs);Cu=o(Li,`Prepares a PyTorch Scheduler for training in any distributed setup. It is recommended to use
`),mo=l(Li,"A",{href:!0});var m1=n(mo);qu=o(m1,"Accelerator.prepare()"),m1.forEach(r),Nu=o(Li," instead."),Li.forEach(r),Mu=h(No),b(Pa.$$.fragment,No),No.forEach(r),Uu=h(P),Oe=l(P,"DIV",{class:!0});var Mo=n(Oe);b(ws.$$.fragment,Mo),Ru=h(Mo),ys=l(Mo,"P",{});var Ii=n(ys);Gu=o(Ii,"Drop in replacement of "),Sl=l(Ii,"CODE",{});var h1=n(Sl);Vu=o(h1,"print()"),h1.forEach(r),Wu=o(Ii," to only print once per server."),Ii.forEach(r),Hu=h(Mo),b(Da.$$.fragment,Mo),Mo.forEach(r),Fu=h(P),re=l(P,"DIV",{class:!0});var tr=n(re);b(ks.$$.fragment,tr),Yu=h(tr),ot=l(tr,"P",{});var Uo=n(ot);Bu=o(Uo,"Reduce the values in "),Cl=l(Uo,"EM",{});var g1=n(Cl);Ju=o(g1,"tensor"),g1.forEach(r),Ku=o(Uo," across all processes based on "),ql=l(Uo,"EM",{});var f1=n(ql);Qu=o(f1,"reduction"),f1.forEach(r),Xu=o(Uo,"."),Uo.forEach(r),Zu=h(tr),Nl=l(tr,"P",{});var u1=n(Nl);e_=o(u1,`Note:
All processes get the reduced value.`),u1.forEach(r),t_=h(tr),b(za.$$.fragment,tr),tr.forEach(r),a_=h(P),H=l(P,"DIV",{class:!0});var Ne=n(H);b(js.$$.fragment,Ne),r_=h(Ne),de=l(Ne,"P",{});var ar=n(de);s_=o(ar,"Makes note of "),Ml=l(ar,"CODE",{});var _1=n(Ml);o_=o(_1,"objects"),_1.forEach(r),c_=o(ar," and will save or load them in during "),Ul=l(ar,"CODE",{});var $1=n(Ul);l_=o($1,"save_state"),$1.forEach(r),n_=o(ar," or "),Rl=l(ar,"CODE",{});var v1=n(Rl);p_=o(v1,"load_state"),v1.forEach(r),i_=o(ar,"."),ar.forEach(r),d_=h(Ne),Gl=l(Ne,"P",{});var b1=n(Gl);m_=o(b1,`These should be utilized when the state is being loaded or saved in the same script. It is not designed to be
used in different scripts.`),b1.forEach(r),h_=h(Ne),b(Ta.$$.fragment,Ne),g_=h(Ne),b(Oa.$$.fragment,Ne),Ne.forEach(r),f_=h(P),M=l(P,"DIV",{class:!0});var oe=n(M);b(As.$$.fragment,oe),u_=h(oe),ct=l(oe,"P",{});var Ro=n(ct);__=o(Ro,"Registers a pre hook to be run before "),Vl=l(Ro,"CODE",{});var w1=n(Vl);$_=o(w1,"load_checkpoint"),w1.forEach(r),v_=o(Ro," is called in "),ho=l(Ro,"A",{href:!0});var y1=n(ho);b_=o(y1,"Accelerator.load_state()"),y1.forEach(r),w_=o(Ro,"."),Ro.forEach(r),y_=h(oe),Wl=l(oe,"P",{});var k1=n(Wl);k_=o(k1,"The hook should have the following signature:"),k1.forEach(r),j_=h(oe),Hl=l(oe,"P",{});var j1=n(Hl);Fl=l(j1,"CODE",{});var A1=n(Fl);A_=o(A1,"hook(models: List[torch.nn.Module], input_dir: str) -> None"),A1.forEach(r),j1.forEach(r),E_=h(oe),V=l(oe,"P",{});var ce=n(V);x_=o(ce,"The "),Yl=l(ce,"CODE",{});var E1=n(Yl);P_=o(E1,"models"),E1.forEach(r),D_=o(ce," argument are the models as saved in the accelerator state under "),Bl=l(ce,"CODE",{});var x1=n(Bl);z_=o(x1,"accelerator._models"),x1.forEach(r),T_=o(ce,`, and the
`),Jl=l(ce,"CODE",{});var P1=n(Jl);O_=o(P1,"input_dir"),P1.forEach(r),L_=o(ce," argument is the "),Kl=l(ce,"CODE",{});var D1=n(Kl);I_=o(D1,"input_dir"),D1.forEach(r),S_=o(ce," argument passed to "),go=l(ce,"A",{href:!0});var z1=n(go);C_=o(z1,"Accelerator.load_state()"),z1.forEach(r),q_=o(ce,"."),ce.forEach(r),N_=h(oe),b(La.$$.fragment,oe),oe.forEach(r),M_=h(P),U=l(P,"DIV",{class:!0});var le=n(U);b(Es.$$.fragment,le),U_=h(le),lt=l(le,"P",{});var Go=n(lt);R_=o(Go,"Registers a pre hook to be run before "),Ql=l(Go,"CODE",{});var T1=n(Ql);G_=o(T1,"save_checkpoint"),T1.forEach(r),V_=o(Go," is called in "),fo=l(Go,"A",{href:!0});var O1=n(fo);W_=o(O1,"Accelerator.save_state()"),O1.forEach(r),H_=o(Go,"."),Go.forEach(r),F_=h(le),Xl=l(le,"P",{});var L1=n(Xl);Y_=o(L1,"The hook should have the following signature:"),L1.forEach(r),B_=h(le),Zl=l(le,"P",{});var I1=n(Zl);en=l(I1,"CODE",{});var S1=n(en);J_=o(S1,"hook(models: List[torch.nn.Module], weights: List[Dict[str, torch.Tensor]], input_dir: str) -> None"),S1.forEach(r),I1.forEach(r),K_=h(le),C=l(le,"P",{});var G=n(C);Q_=o(G,"The "),tn=l(G,"CODE",{});var C1=n(tn);X_=o(C1,"models"),C1.forEach(r),Z_=o(G," argument are the models as saved in the accelerator state under "),an=l(G,"CODE",{});var q1=n(an);e$=o(q1,"accelerator._models"),q1.forEach(r),t$=o(G,", "),rn=l(G,"CODE",{});var N1=n(rn);a$=o(N1,"weigths"),N1.forEach(r),r$=o(G,`
argument are the state dicts of the `),sn=l(G,"CODE",{});var M1=n(sn);s$=o(M1,"models"),M1.forEach(r),o$=o(G,", and the "),on=l(G,"CODE",{});var U1=n(on);c$=o(U1,"input_dir"),U1.forEach(r),l$=o(G," argument is the "),cn=l(G,"CODE",{});var R1=n(cn);n$=o(R1,"input_dir"),R1.forEach(r),p$=o(G,` argument passed
to `),uo=l(G,"A",{href:!0});var G1=n(uo);i$=o(G1,"Accelerator.load_state()"),G1.forEach(r),d$=o(G,"."),G.forEach(r),m$=h(le),b(Ia.$$.fragment,le),le.forEach(r),h$=h(P),Le=l(P,"DIV",{class:!0});var Vo=n(Le);b(xs.$$.fragment,Vo),g$=h(Vo),Ps=l(Vo,"P",{});var Si=n(Ps);f$=o(Si,"Save the object passed to disk once per machine. Use in place of "),ln=l(Si,"CODE",{});var V1=n(ln);u$=o(V1,"torch.save"),V1.forEach(r),_$=o(Si,"."),Si.forEach(r),$$=h(Vo),b(Sa.$$.fragment,Vo),Vo.forEach(r),v$=h(P),R=l(P,"DIV",{class:!0});var ne=n(R);b(Ds.$$.fragment,ne),b$=h(ne),nn=l(ne,"P",{});var W1=n(nn);w$=o(W1,"Saves the current states of the model, optimizer, scaler, RNG generators, and registered objects to a folder."),W1.forEach(r),y$=h(ne),N=l(ne,"P",{});var F=n(N);k$=o(F,"If a "),pn=l(F,"CODE",{});var H1=n(pn);j$=o(H1,"ProjectConfiguration"),H1.forEach(r),A$=o(F," was passed to the "),dn=l(F,"CODE",{});var F1=n(dn);E$=o(F1,"Accelerator"),F1.forEach(r),x$=o(F," object with "),mn=l(F,"CODE",{});var Y1=n(mn);P$=o(Y1,"automatic_checkpoint_naming"),Y1.forEach(r),D$=o(F,` enabled
then checkpoints will be saved to `),hn=l(F,"CODE",{});var B1=n(hn);z$=o(B1,"self.project_dir/checkpoints"),B1.forEach(r),T$=o(F,`. If the number of current saves is greater
than `),gn=l(F,"CODE",{});var J1=n(gn);O$=o(J1,"total_limit"),J1.forEach(r),L$=o(F,` then the oldest save is deleted. Each checkpoint is saved in seperate folders named
`),fn=l(F,"CODE",{});var K1=n(fn);I$=o(K1,"checkpoint_<iteration>"),K1.forEach(r),S$=o(F,"."),F.forEach(r),C$=h(ne),zs=l(ne,"P",{});var Ci=n(zs);q$=o(Ci,"Otherwise they are just saved to "),un=l(Ci,"CODE",{});var Q1=n(un);N$=o(Q1,"output_dir"),Q1.forEach(r),M$=o(Ci,"."),Ci.forEach(r),U$=h(ne),b(Ca.$$.fragment,ne),R$=h(ne),b(qa.$$.fragment,ne),ne.forEach(r),G$=h(P),Ie=l(P,"DIV",{class:!0});var Wo=n(Ie);b(Ts.$$.fragment,Wo),V$=h(Wo),nt=l(Wo,"P",{});var Ho=n(nt);W$=o(Ho,"Creates a new "),_n=l(Ho,"CODE",{});var X1=n(_n);H$=o(X1,"torch.utils.data.DataLoader"),X1.forEach(r),F$=o(Ho," that will efficiently skip the first "),$n=l(Ho,"CODE",{});var Z1=n($n);Y$=o(Z1,"num_batches"),Z1.forEach(r),B$=o(Ho,"."),Ho.forEach(r),J$=h(Wo),b(Na.$$.fragment,Wo),Wo.forEach(r),K$=h(P),se=l(P,"DIV",{class:!0});var rr=n(se);b(Os.$$.fragment,rr),Q$=h(rr),vn=l(rr,"P",{});var e2=n(vn);X$=o(e2,"Unscale the gradients in mixed precision training with AMP. This is a noop in all other settings."),e2.forEach(r),Z$=h(rr),Ma=l(rr,"P",{});var pp=n(Ma);ev=o(pp,"Likely should be called through "),Ua=l(pp,"A",{href:!0});var qi=n(Ua);tv=o(qi,"Accelerator.clip"),bn=l(qi,"EM",{});var t2=n(bn);av=o(t2,"grad_norm"),t2.forEach(r),rv=o(qi,"()"),qi.forEach(r),sv=o(pp," or "),Ra=l(pp,"A",{href:!0});var Ni=n(Ra);ov=o(Ni,"Accelerator.clip"),wn=l(Ni,"EM",{});var a2=n(wn);cv=o(a2,"grad_value"),a2.forEach(r),lv=o(Ni,"()"),Ni.forEach(r),pp.forEach(r),nv=h(rr),b(Ga.$$.fragment,rr),rr.forEach(r),pv=h(P),Se=l(P,"DIV",{class:!0});var Fo=n(Se);b(Ls.$$.fragment,Fo),iv=h(Fo),pt=l(Fo,"P",{});var Yo=n(pt);dv=o(Yo,"Unwraps the "),yn=l(Yo,"CODE",{});var r2=n(yn);mv=o(r2,"model"),r2.forEach(r),hv=o(Yo," from the additional layer possible added by "),_o=l(Yo,"A",{href:!0});var s2=n(_o);gv=o(s2,"prepare()"),s2.forEach(r),fv=o(Yo,`. Useful before saving
the model.`),Yo.forEach(r),uv=h(Fo),b(Va.$$.fragment,Fo),Fo.forEach(r),_v=h(P),Ce=l(P,"DIV",{class:!0});var Bo=n(Ce);b(Is.$$.fragment,Bo),$v=h(Bo),kn=l(Bo,"P",{});var o2=n(kn);vv=o(o2,`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),o2.forEach(r),bv=h(Bo),b(Wa.$$.fragment,Bo),Bo.forEach(r),P.forEach(r),this.h()},h(){A(p,"name","hf:doc:metadata"),A(p,"content",JSON.stringify(aw)),A(i,"id","accelerator"),A(i,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(i,"href","#accelerator"),A(g,"class","relative group"),A(q,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator"),A(gt,"id","quick-adaptation-of-your-code"),A(gt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(gt,"href","#quick-adaptation-of-your-code"),A(Ge,"class","relative group"),A(Ys,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator"),A(Bs,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(Ks,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.gather"),A(We,"start","4"),A(vt,"id","advanced-recommendations"),A(vt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(vt,"href","#advanced-recommendations"),A(He,"class","relative group"),A(bt,"id","printing"),A(bt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(bt,"href","#printing"),A(Fe,"class","relative group"),A(Qs,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.print"),A(wt,"id","executing-processes"),A(wt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(wt,"href","#executing-processes"),A(Be,"class","relative group"),A(yt,"id","once-on-a-single-server"),A(yt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(yt,"href","#once-on-a-single-server"),A(Je,"class","relative group"),A(Xs,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.on_local_main_process"),A(At,"id","only-ever-once-across-all-servers"),A(At,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(At,"href","#only-ever-once-across-all-servers"),A(Ke,"class","relative group"),A(Zs,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.on_main_process"),A(Pt,"id","on-specific-processes"),A(Pt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Pt,"href","#on-specific-processes"),A(Qe,"class","relative group"),A(Dt,"id","synchronicity-control"),A(Dt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Dt,"href","#synchronicity-control"),A(Xe,"class","relative group"),A(to,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.wait_for_everyone"),A(Tt,"id","saving-and-loading"),A(Tt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Tt,"href","#saving-and-loading"),A(Ze,"class","relative group"),A(ao,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.unwrap_model"),A(ro,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.save"),A(Lt,"id","operations"),A(Lt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Lt,"href","#operations"),A(et,"class","relative group"),A(It,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_norm_"),A(St,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_value_"),A(Ct,"id","gradient-accumulation"),A(Ct,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Ct,"href","#gradient-accumulation"),A(tt,"class","relative group"),A(so,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.accumulate"),A(Nt,"id","accelerate.Accelerator"),A(Nt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),A(Nt,"href","#accelerate.Accelerator"),A(at,"class","relative group"),A(oo,"href","/docs/accelerate/v0.16.0/en/package_reference/utilities#accelerate.DistributedType"),A(co,"href","/docs/accelerate/v0.16.0/en/package_reference/state#accelerate.state.AcceleratorState"),A(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(lo,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(_a,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A($a,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(va,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ba,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(wa,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(no,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(Pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(po,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(De,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(io,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(mo,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(Te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(ho,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.load_state"),A(go,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.load_state"),A(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(fo,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.save_state"),A(uo,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.load_state"),A(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Ua,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_norm_"),A(Ra,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.clip_grad_value_"),A(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(_o,"href","/docs/accelerate/v0.16.0/en/package_reference/accelerator#accelerate.Accelerator.prepare"),A(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(Ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),A(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(a,_){e(document.head,p),$(a,u,_),$(a,g,_),e(g,i),e(i,f),w(t,f,null),e(g,d),e(g,I),e(I,Ue),$(a,ht,_),$(a,J,_),e(J,Re),e(J,q),e(q,Ws),e(J,Hs),$(a,sr,_),$(a,Ge,_),e(Ge,gt),e(gt,Jo),w(or,Jo,null),e(Ge,Mi),e(Ge,Ko),e(Ko,Ui),$(a,ip,_),$(a,Fs,_),e(Fs,Ri),$(a,dp,_),$(a,he,_),e(he,Ve),e(Ve,Gi),e(Ve,Ys),e(Ys,Vi),e(Ve,Wi),e(Ve,Qo),e(Qo,Hi),e(Ve,Fi),e(he,Yi),e(he,cr),e(cr,Bi),e(cr,Bs),e(Bs,Ji),e(cr,Ki),e(he,Qi),e(he,pe),e(pe,Xi),e(pe,Xo),e(Xo,Zi),e(pe,ed),e(pe,Zo),e(Zo,td),e(pe,ad),e(pe,ec),e(ec,rd),e(pe,sd),$(a,mp,_),w(ft,a,_),$(a,hp,_),$(a,We,_),e(We,ut),e(ut,od),e(ut,tc),e(tc,cd),e(ut,ld),e(ut,ac),e(ac,nd),e(We,pd),e(We,Js),e(Js,id),e(Js,Ks),e(Ks,dd),$(a,gp,_),w(_t,a,_),$(a,fp,_),$(a,$t,_),e($t,md),e($t,rc),e(rc,hd),e($t,gd),$(a,up,_),$(a,He,_),e(He,vt),e(vt,sc),w(lr,sc,null),e(He,fd),e(He,oc),e(oc,ud),$(a,_p,_),$(a,Fe,_),e(Fe,bt),e(bt,cc),w(nr,cc,null),e(Fe,_d),e(Fe,lc),e(lc,$d),$(a,$p,_),$(a,Ye,_),e(Ye,nc),e(nc,vd),e(Ye,bd),e(Ye,Qs),e(Qs,wd),e(Ye,yd),$(a,vp,_),w(pr,a,_),$(a,bp,_),$(a,Be,_),e(Be,wt),e(wt,pc),w(ir,pc,null),e(Be,kd),e(Be,ic),e(ic,jd),$(a,wp,_),$(a,Je,_),e(Je,yt),e(yt,dc),w(dr,dc,null),e(Je,Ad),e(Je,mc),e(mc,Ed),$(a,yp,_),$(a,kt,_),e(kt,xd),e(kt,hc),e(hc,Pd),e(kt,Dd),$(a,kp,_),w(mr,a,_),$(a,jp,_),$(a,jt,_),e(jt,zd),e(jt,Xs),e(Xs,Td),e(jt,Od),$(a,Ap,_),w(hr,a,_),$(a,Ep,_),$(a,Ke,_),e(Ke,At),e(At,gc),w(gr,gc,null),e(Ke,Ld),e(Ke,fc),e(fc,Id),$(a,xp,_),$(a,Et,_),e(Et,Sd),e(Et,uc),e(uc,Cd),e(Et,qd),$(a,Pp,_),w(fr,a,_),$(a,Dp,_),$(a,xt,_),e(xt,Nd),e(xt,Zs),e(Zs,Md),e(xt,Ud),$(a,zp,_),w(ur,a,_),$(a,Tp,_),$(a,Qe,_),e(Qe,Pt),e(Pt,_c),w(_r,_c,null),e(Qe,Rd),e(Qe,$c),e($c,Gd),$(a,Op,_),$(a,eo,_),e(eo,Vd),$(a,Lp,_),w($r,a,_),$(a,Ip,_),w(vr,a,_),$(a,Sp,_),$(a,Xe,_),e(Xe,Dt),e(Dt,vc),w(br,vc,null),e(Xe,Wd),e(Xe,bc),e(bc,Hd),$(a,Cp,_),$(a,zt,_),e(zt,Fd),e(zt,to),e(to,Yd),e(zt,Bd),$(a,qp,_),$(a,Ze,_),e(Ze,Tt),e(Tt,wc),w(wr,wc,null),e(Ze,Jd),e(Ze,yc),e(yc,Kd),$(a,Np,_),$(a,Ot,_),e(Ot,Qd),e(Ot,ao),e(ao,Xd),e(Ot,Zd),$(a,Mp,_),w(yr,a,_),$(a,Up,_),$(a,ge,_),e(ge,em),e(ge,ro),e(ro,tm),e(ge,am),e(ge,kc),e(kc,rm),e(ge,sm),$(a,Rp,_),w(kr,a,_),$(a,Gp,_),$(a,et,_),e(et,Lt),e(Lt,jc),w(jr,jc,null),e(et,om),e(et,Ac),e(Ac,cm),$(a,Vp,_),$(a,Y,_),e(Y,lm),e(Y,It),e(It,nm),e(It,Ec),e(Ec,pm),e(It,im),e(Y,dm),e(Y,xc),e(xc,mm),e(Y,hm),e(Y,St),e(St,gm),e(St,Pc),e(Pc,fm),e(St,um),e(Y,_m),e(Y,Dc),e(Dc,$m),$(a,Wp,_),$(a,tt,_),e(tt,Ct),e(Ct,zc),w(Ar,zc,null),e(tt,vm),e(tt,Tc),e(Tc,bm),$(a,Hp,_),$(a,qt,_),e(qt,wm),e(qt,so),e(so,ym),e(qt,km),$(a,Fp,_),w(Er,a,_),$(a,Yp,_),$(a,at,_),e(at,Nt),e(Nt,Oc),w(xr,Oc,null),e(at,jm),e(at,Lc),e(Lc,Am),$(a,Bp,_),$(a,E,_),w(Pr,E,null),e(E,Em),e(E,Ic),e(Ic,xm),e(E,Pm),e(E,Sc),e(Sc,Cc),e(Cc,Dm),e(E,zm),e(E,L),e(L,Mt),e(Mt,qc),e(qc,Tm),e(Mt,Om),e(Mt,Nc),e(Nc,Lm),e(Mt,Im),e(L,Sm),e(L,Ut),e(Ut,Mc),e(Mc,Cm),e(Ut,qm),e(Ut,oo),e(oo,Nm),e(Ut,Mm),e(L,Um),e(L,Rt),e(Rt,Uc),e(Uc,Rm),e(Rt,Gm),e(Rt,Rc),e(Rc,Vm),e(Rt,Wm),e(L,Hm),e(L,Gt),e(Gt,Gc),e(Gc,Fm),e(Gt,Ym),e(Gt,Vc),e(Vc,Bm),e(Gt,Jm),e(L,Km),e(L,Vt),e(Vt,Wc),e(Wc,Qm),e(Vt,Xm),e(Vt,Hc),e(Hc,Zm),e(Vt,eh),e(L,th),e(L,Wt),e(Wt,Fc),e(Fc,ah),e(Wt,rh),e(Wt,Yc),e(Yc,sh),e(Wt,oh),e(L,ch),e(L,Ht),e(Ht,Bc),e(Bc,lh),e(Ht,nh),e(Ht,Jc),e(Jc,ph),e(Ht,ih),e(L,dh),e(L,Ft),e(Ft,Kc),e(Kc,mh),e(Ft,hh),e(Ft,co),e(co,gh),e(Ft,fh),e(L,uh),e(L,Yt),e(Yt,Qc),e(Qc,_h),e(Yt,$h),e(Yt,Xc),e(Xc,vh),e(Yt,bh),e(L,wh),e(L,Bt),e(Bt,Zc),e(Zc,yh),e(Bt,kh),e(Bt,el),e(el,jh),e(Bt,Ah),e(E,Eh),e(E,fe),w(Dr,fe,null),e(fe,xh),e(fe,tl),e(tl,Ph),e(fe,Dh),w(Jt,fe,null),e(E,zh),e(E,ue),w(zr,ue,null),e(ue,Th),e(ue,al),e(al,Oh),e(ue,Lh),w(Kt,ue,null),e(E,Ih),e(E,K),w(Tr,K,null),e(K,Sh),e(K,rt),e(rt,Ch),e(rt,rl),e(rl,qh),e(rt,Nh),e(rt,sl),e(sl,Mh),e(rt,Uh),e(K,Rh),e(K,Or),e(Or,Gh),e(Or,ol),e(ol,Vh),e(Or,Wh),e(K,Hh),w(Qt,K,null),e(E,Fh),e(E,_e),w(Lr,_e,null),e(_e,Yh),e(_e,Ir),e(Ir,Bh),e(Ir,cl),e(cl,Jh),e(Ir,Kh),e(_e,Qh),w(Xt,_e,null),e(E,Xh),e(E,$e),w(Sr,$e,null),e($e,Zh),e($e,Cr),e(Cr,eg),e(Cr,ll),e(ll,tg),e(Cr,ag),e($e,rg),w(Zt,$e,null),e(E,sg),e(E,ve),w(qr,ve,null),e(ve,og),e(ve,Nr),e(Nr,cg),e(Nr,nl),e(nl,lg),e(Nr,ng),e(ve,pg),w(ea,ve,null),e(E,ig),e(E,be),w(Mr,be,null),e(be,dg),e(be,pl),e(pl,mg),e(be,hg),w(ta,be,null),e(E,gg),e(E,we),w(Ur,we,null),e(we,fg),e(we,il),e(il,ug),e(we,_g),w(aa,we,null),e(E,$g),e(E,Q),w(Rr,Q,null),e(Q,vg),e(Q,Gr),e(Gr,bg),e(Gr,dl),e(dl,wg),e(Gr,yg),e(Q,kg),e(Q,ml),e(ml,jg),e(Q,Ag),w(ra,Q,null),e(E,Eg),e(E,ye),w(Vr,ye,null),e(ye,xg),e(ye,Wr),e(Wr,Pg),e(Wr,hl),e(hl,Dg),e(Wr,zg),e(ye,Tg),w(sa,ye,null),e(E,Og),e(E,ke),w(Hr,ke,null),e(ke,Lg),e(ke,Fr),e(Fr,Ig),e(Fr,lo),e(lo,Sg),e(Fr,Cg),e(ke,qg),w(oa,ke,null),e(E,Ng),e(E,je),w(Yr,je,null),e(je,Mg),e(je,ie),e(ie,Ug),e(ie,gl),e(gl,Rg),e(ie,Gg),e(ie,fl),e(fl,Vg),e(ie,Wg),e(ie,ul),e(ul,Hg),e(ie,Fg),e(je,Yg),w(ca,je,null),e(E,Bg),e(E,Ae),w(Br,Ae,null),e(Ae,Jg),e(Ae,Jr),e(Jr,Kg),e(Jr,_l),e(_l,Qg),e(Jr,Xg),e(Ae,Zg),w(la,Ae,null),e(E,ef),e(E,W),w(Kr,W,null),e(W,tf),e(W,Qr),e(Qr,af),e(Qr,$l),e($l,rf),e(Qr,sf),e(W,of),w(na,W,null),e(W,cf),w(pa,W,null),e(W,lf),w(ia,W,null),e(E,nf),e(E,X),w(Xr,X,null),e(X,pf),e(X,vl),e(vl,df),e(X,mf),w(da,X,null),e(X,hf),w(ma,X,null),e(E,gf),e(E,Z),w(Zr,Z,null),e(Z,ff),e(Z,bl),e(bl,uf),e(Z,_f),e(Z,wl),e(wl,$f),e(Z,vf),w(ha,Z,null),e(E,bf),e(E,Ee),w(es,Ee,null),e(Ee,wf),e(Ee,st),e(st,yf),e(st,yl),e(yl,kf),e(st,jf),e(st,kl),e(kl,Af),e(st,Ef),e(Ee,xf),w(ga,Ee,null),e(E,Pf),e(E,ee),w(ts,ee,null),e(ee,Df),e(ee,jl),e(jl,zf),e(ee,Tf),e(ee,Al),e(Al,Of),e(ee,Lf),w(fa,ee,null),e(E,If),e(E,te),w(as,te,null),e(te,Sf),e(te,rs),e(rs,Cf),e(rs,El),e(El,qf),e(rs,Nf),e(te,Mf),e(te,ss),e(ss,Uf),e(ss,xl),e(xl,Rf),e(ss,Gf),e(te,Vf),w(ua,te,null),e(E,Wf),e(E,_a),w(os,_a,null),e(_a,Hf),e(_a,Pl),e(Pl,Ff),e(E,Yf),e(E,$a),w(cs,$a,null),e($a,Bf),e($a,Dl),e(Dl,Jf),e(E,Kf),e(E,va),w(ls,va,null),e(va,Qf),e(va,zl),e(zl,Xf),e(E,Zf),e(E,ba),w(ns,ba,null),e(ba,eu),e(ba,Tl),e(Tl,tu),e(E,au),e(E,wa),w(ps,wa,null),e(wa,ru),e(wa,Ol),e(Ol,su),e(E,ou),e(E,xe),w(is,xe,null),e(xe,cu),e(xe,Ll),e(Ll,lu),e(xe,nu),w(ya,xe,null),e(E,pu),e(E,ae),w(ds,ae,null),e(ae,iu),e(ae,ms),e(ms,du),e(ms,Il),e(Il,mu),e(ms,hu),e(ae,gu),w(ka,ae,null),e(ae,fu),w(ja,ae,null),e(E,uu),e(E,Pe),w(hs,Pe,null),e(Pe,_u),e(Pe,gs),e(gs,$u),e(gs,no),e(no,vu),e(gs,bu),e(Pe,wu),w(Aa,Pe,null),e(E,yu),e(E,De),w(fs,De,null),e(De,ku),e(De,us),e(us,ju),e(us,po),e(po,Au),e(us,Eu),e(De,xu),w(Ea,De,null),e(E,Pu),e(E,ze),w(_s,ze,null),e(ze,Du),e(ze,$s),e($s,zu),e($s,io),e(io,Tu),e($s,Ou),e(ze,Lu),w(xa,ze,null),e(E,Iu),e(E,Te),w(vs,Te,null),e(Te,Su),e(Te,bs),e(bs,Cu),e(bs,mo),e(mo,qu),e(bs,Nu),e(Te,Mu),w(Pa,Te,null),e(E,Uu),e(E,Oe),w(ws,Oe,null),e(Oe,Ru),e(Oe,ys),e(ys,Gu),e(ys,Sl),e(Sl,Vu),e(ys,Wu),e(Oe,Hu),w(Da,Oe,null),e(E,Fu),e(E,re),w(ks,re,null),e(re,Yu),e(re,ot),e(ot,Bu),e(ot,Cl),e(Cl,Ju),e(ot,Ku),e(ot,ql),e(ql,Qu),e(ot,Xu),e(re,Zu),e(re,Nl),e(Nl,e_),e(re,t_),w(za,re,null),e(E,a_),e(E,H),w(js,H,null),e(H,r_),e(H,de),e(de,s_),e(de,Ml),e(Ml,o_),e(de,c_),e(de,Ul),e(Ul,l_),e(de,n_),e(de,Rl),e(Rl,p_),e(de,i_),e(H,d_),e(H,Gl),e(Gl,m_),e(H,h_),w(Ta,H,null),e(H,g_),w(Oa,H,null),e(E,f_),e(E,M),w(As,M,null),e(M,u_),e(M,ct),e(ct,__),e(ct,Vl),e(Vl,$_),e(ct,v_),e(ct,ho),e(ho,b_),e(ct,w_),e(M,y_),e(M,Wl),e(Wl,k_),e(M,j_),e(M,Hl),e(Hl,Fl),e(Fl,A_),e(M,E_),e(M,V),e(V,x_),e(V,Yl),e(Yl,P_),e(V,D_),e(V,Bl),e(Bl,z_),e(V,T_),e(V,Jl),e(Jl,O_),e(V,L_),e(V,Kl),e(Kl,I_),e(V,S_),e(V,go),e(go,C_),e(V,q_),e(M,N_),w(La,M,null),e(E,M_),e(E,U),w(Es,U,null),e(U,U_),e(U,lt),e(lt,R_),e(lt,Ql),e(Ql,G_),e(lt,V_),e(lt,fo),e(fo,W_),e(lt,H_),e(U,F_),e(U,Xl),e(Xl,Y_),e(U,B_),e(U,Zl),e(Zl,en),e(en,J_),e(U,K_),e(U,C),e(C,Q_),e(C,tn),e(tn,X_),e(C,Z_),e(C,an),e(an,e$),e(C,t$),e(C,rn),e(rn,a$),e(C,r$),e(C,sn),e(sn,s$),e(C,o$),e(C,on),e(on,c$),e(C,l$),e(C,cn),e(cn,n$),e(C,p$),e(C,uo),e(uo,i$),e(C,d$),e(U,m$),w(Ia,U,null),e(E,h$),e(E,Le),w(xs,Le,null),e(Le,g$),e(Le,Ps),e(Ps,f$),e(Ps,ln),e(ln,u$),e(Ps,_$),e(Le,$$),w(Sa,Le,null),e(E,v$),e(E,R),w(Ds,R,null),e(R,b$),e(R,nn),e(nn,w$),e(R,y$),e(R,N),e(N,k$),e(N,pn),e(pn,j$),e(N,A$),e(N,dn),e(dn,E$),e(N,x$),e(N,mn),e(mn,P$),e(N,D$),e(N,hn),e(hn,z$),e(N,T$),e(N,gn),e(gn,O$),e(N,L$),e(N,fn),e(fn,I$),e(N,S$),e(R,C$),e(R,zs),e(zs,q$),e(zs,un),e(un,N$),e(zs,M$),e(R,U$),w(Ca,R,null),e(R,R$),w(qa,R,null),e(E,G$),e(E,Ie),w(Ts,Ie,null),e(Ie,V$),e(Ie,nt),e(nt,W$),e(nt,_n),e(_n,H$),e(nt,F$),e(nt,$n),e($n,Y$),e(nt,B$),e(Ie,J$),w(Na,Ie,null),e(E,K$),e(E,se),w(Os,se,null),e(se,Q$),e(se,vn),e(vn,X$),e(se,Z$),e(se,Ma),e(Ma,ev),e(Ma,Ua),e(Ua,tv),e(Ua,bn),e(bn,av),e(Ua,rv),e(Ma,sv),e(Ma,Ra),e(Ra,ov),e(Ra,wn),e(wn,cv),e(Ra,lv),e(se,nv),w(Ga,se,null),e(E,pv),e(E,Se),w(Ls,Se,null),e(Se,iv),e(Se,pt),e(pt,dv),e(pt,yn),e(yn,mv),e(pt,hv),e(pt,_o),e(_o,gv),e(pt,fv),e(Se,uv),w(Va,Se,null),e(E,_v),e(E,Ce),w(Is,Ce,null),e(Ce,$v),e(Ce,kn),e(kn,vv),e(Ce,bv),w(Wa,Ce,null),Jp=!0},p(a,[_]){const Ss={};_&2&&(Ss.$$scope={dirty:_,ctx:a}),ft.$set(Ss);const jn={};_&2&&(jn.$$scope={dirty:_,ctx:a}),_t.$set(jn);const An={};_&2&&(An.$$scope={dirty:_,ctx:a}),Jt.$set(An);const En={};_&2&&(En.$$scope={dirty:_,ctx:a}),Kt.$set(En);const Cs={};_&2&&(Cs.$$scope={dirty:_,ctx:a}),Qt.$set(Cs);const xn={};_&2&&(xn.$$scope={dirty:_,ctx:a}),Xt.$set(xn);const qs={};_&2&&(qs.$$scope={dirty:_,ctx:a}),Zt.$set(qs);const Pn={};_&2&&(Pn.$$scope={dirty:_,ctx:a}),ea.$set(Pn);const Dn={};_&2&&(Dn.$$scope={dirty:_,ctx:a}),ta.$set(Dn);const zn={};_&2&&(zn.$$scope={dirty:_,ctx:a}),aa.$set(zn);const Tn={};_&2&&(Tn.$$scope={dirty:_,ctx:a}),ra.$set(Tn);const it={};_&2&&(it.$$scope={dirty:_,ctx:a}),sa.$set(it);const dt={};_&2&&(dt.$$scope={dirty:_,ctx:a}),oa.$set(dt);const On={};_&2&&(On.$$scope={dirty:_,ctx:a}),ca.$set(On);const Ln={};_&2&&(Ln.$$scope={dirty:_,ctx:a}),la.$set(Ln);const Ns={};_&2&&(Ns.$$scope={dirty:_,ctx:a}),na.$set(Ns);const In={};_&2&&(In.$$scope={dirty:_,ctx:a}),pa.$set(In);const me={};_&2&&(me.$$scope={dirty:_,ctx:a}),ia.$set(me);const Sn={};_&2&&(Sn.$$scope={dirty:_,ctx:a}),da.$set(Sn);const Cn={};_&2&&(Cn.$$scope={dirty:_,ctx:a}),ma.$set(Cn);const qn={};_&2&&(qn.$$scope={dirty:_,ctx:a}),ha.$set(qn);const Ms={};_&2&&(Ms.$$scope={dirty:_,ctx:a}),ga.$set(Ms);const Ha={};_&2&&(Ha.$$scope={dirty:_,ctx:a}),fa.$set(Ha);const Nn={};_&2&&(Nn.$$scope={dirty:_,ctx:a}),ua.$set(Nn);const Mn={};_&2&&(Mn.$$scope={dirty:_,ctx:a}),ya.$set(Mn);const $o={};_&2&&($o.$$scope={dirty:_,ctx:a}),ka.$set($o);const Un={};_&2&&(Un.$$scope={dirty:_,ctx:a}),ja.$set(Un);const Us={};_&2&&(Us.$$scope={dirty:_,ctx:a}),Aa.$set(Us);const Rn={};_&2&&(Rn.$$scope={dirty:_,ctx:a}),Ea.$set(Rn);const Rs={};_&2&&(Rs.$$scope={dirty:_,ctx:a}),xa.$set(Rs);const Gn={};_&2&&(Gn.$$scope={dirty:_,ctx:a}),Pa.$set(Gn);const Vn={};_&2&&(Vn.$$scope={dirty:_,ctx:a}),Da.$set(Vn);const Wn={};_&2&&(Wn.$$scope={dirty:_,ctx:a}),za.$set(Wn);const Gs={};_&2&&(Gs.$$scope={dirty:_,ctx:a}),Ta.$set(Gs);const Hn={};_&2&&(Hn.$$scope={dirty:_,ctx:a}),Oa.$set(Hn);const Fn={};_&2&&(Fn.$$scope={dirty:_,ctx:a}),La.$set(Fn);const Yn={};_&2&&(Yn.$$scope={dirty:_,ctx:a}),Ia.$set(Yn);const Fa={};_&2&&(Fa.$$scope={dirty:_,ctx:a}),Sa.$set(Fa);const Bn={};_&2&&(Bn.$$scope={dirty:_,ctx:a}),Ca.$set(Bn);const Jn={};_&2&&(Jn.$$scope={dirty:_,ctx:a}),qa.$set(Jn);const Vs={};_&2&&(Vs.$$scope={dirty:_,ctx:a}),Na.$set(Vs);const Kn={};_&2&&(Kn.$$scope={dirty:_,ctx:a}),Ga.$set(Kn);const Qn={};_&2&&(Qn.$$scope={dirty:_,ctx:a}),Va.$set(Qn);const Xn={};_&2&&(Xn.$$scope={dirty:_,ctx:a}),Wa.$set(Xn)},i(a){Jp||(y(t.$$.fragment,a),y(or.$$.fragment,a),y(ft.$$.fragment,a),y(_t.$$.fragment,a),y(lr.$$.fragment,a),y(nr.$$.fragment,a),y(pr.$$.fragment,a),y(ir.$$.fragment,a),y(dr.$$.fragment,a),y(mr.$$.fragment,a),y(hr.$$.fragment,a),y(gr.$$.fragment,a),y(fr.$$.fragment,a),y(ur.$$.fragment,a),y(_r.$$.fragment,a),y($r.$$.fragment,a),y(vr.$$.fragment,a),y(br.$$.fragment,a),y(wr.$$.fragment,a),y(yr.$$.fragment,a),y(kr.$$.fragment,a),y(jr.$$.fragment,a),y(Ar.$$.fragment,a),y(Er.$$.fragment,a),y(xr.$$.fragment,a),y(Pr.$$.fragment,a),y(Dr.$$.fragment,a),y(Jt.$$.fragment,a),y(zr.$$.fragment,a),y(Kt.$$.fragment,a),y(Tr.$$.fragment,a),y(Qt.$$.fragment,a),y(Lr.$$.fragment,a),y(Xt.$$.fragment,a),y(Sr.$$.fragment,a),y(Zt.$$.fragment,a),y(qr.$$.fragment,a),y(ea.$$.fragment,a),y(Mr.$$.fragment,a),y(ta.$$.fragment,a),y(Ur.$$.fragment,a),y(aa.$$.fragment,a),y(Rr.$$.fragment,a),y(ra.$$.fragment,a),y(Vr.$$.fragment,a),y(sa.$$.fragment,a),y(Hr.$$.fragment,a),y(oa.$$.fragment,a),y(Yr.$$.fragment,a),y(ca.$$.fragment,a),y(Br.$$.fragment,a),y(la.$$.fragment,a),y(Kr.$$.fragment,a),y(na.$$.fragment,a),y(pa.$$.fragment,a),y(ia.$$.fragment,a),y(Xr.$$.fragment,a),y(da.$$.fragment,a),y(ma.$$.fragment,a),y(Zr.$$.fragment,a),y(ha.$$.fragment,a),y(es.$$.fragment,a),y(ga.$$.fragment,a),y(ts.$$.fragment,a),y(fa.$$.fragment,a),y(as.$$.fragment,a),y(ua.$$.fragment,a),y(os.$$.fragment,a),y(cs.$$.fragment,a),y(ls.$$.fragment,a),y(ns.$$.fragment,a),y(ps.$$.fragment,a),y(is.$$.fragment,a),y(ya.$$.fragment,a),y(ds.$$.fragment,a),y(ka.$$.fragment,a),y(ja.$$.fragment,a),y(hs.$$.fragment,a),y(Aa.$$.fragment,a),y(fs.$$.fragment,a),y(Ea.$$.fragment,a),y(_s.$$.fragment,a),y(xa.$$.fragment,a),y(vs.$$.fragment,a),y(Pa.$$.fragment,a),y(ws.$$.fragment,a),y(Da.$$.fragment,a),y(ks.$$.fragment,a),y(za.$$.fragment,a),y(js.$$.fragment,a),y(Ta.$$.fragment,a),y(Oa.$$.fragment,a),y(As.$$.fragment,a),y(La.$$.fragment,a),y(Es.$$.fragment,a),y(Ia.$$.fragment,a),y(xs.$$.fragment,a),y(Sa.$$.fragment,a),y(Ds.$$.fragment,a),y(Ca.$$.fragment,a),y(qa.$$.fragment,a),y(Ts.$$.fragment,a),y(Na.$$.fragment,a),y(Os.$$.fragment,a),y(Ga.$$.fragment,a),y(Ls.$$.fragment,a),y(Va.$$.fragment,a),y(Is.$$.fragment,a),y(Wa.$$.fragment,a),Jp=!0)},o(a){k(t.$$.fragment,a),k(or.$$.fragment,a),k(ft.$$.fragment,a),k(_t.$$.fragment,a),k(lr.$$.fragment,a),k(nr.$$.fragment,a),k(pr.$$.fragment,a),k(ir.$$.fragment,a),k(dr.$$.fragment,a),k(mr.$$.fragment,a),k(hr.$$.fragment,a),k(gr.$$.fragment,a),k(fr.$$.fragment,a),k(ur.$$.fragment,a),k(_r.$$.fragment,a),k($r.$$.fragment,a),k(vr.$$.fragment,a),k(br.$$.fragment,a),k(wr.$$.fragment,a),k(yr.$$.fragment,a),k(kr.$$.fragment,a),k(jr.$$.fragment,a),k(Ar.$$.fragment,a),k(Er.$$.fragment,a),k(xr.$$.fragment,a),k(Pr.$$.fragment,a),k(Dr.$$.fragment,a),k(Jt.$$.fragment,a),k(zr.$$.fragment,a),k(Kt.$$.fragment,a),k(Tr.$$.fragment,a),k(Qt.$$.fragment,a),k(Lr.$$.fragment,a),k(Xt.$$.fragment,a),k(Sr.$$.fragment,a),k(Zt.$$.fragment,a),k(qr.$$.fragment,a),k(ea.$$.fragment,a),k(Mr.$$.fragment,a),k(ta.$$.fragment,a),k(Ur.$$.fragment,a),k(aa.$$.fragment,a),k(Rr.$$.fragment,a),k(ra.$$.fragment,a),k(Vr.$$.fragment,a),k(sa.$$.fragment,a),k(Hr.$$.fragment,a),k(oa.$$.fragment,a),k(Yr.$$.fragment,a),k(ca.$$.fragment,a),k(Br.$$.fragment,a),k(la.$$.fragment,a),k(Kr.$$.fragment,a),k(na.$$.fragment,a),k(pa.$$.fragment,a),k(ia.$$.fragment,a),k(Xr.$$.fragment,a),k(da.$$.fragment,a),k(ma.$$.fragment,a),k(Zr.$$.fragment,a),k(ha.$$.fragment,a),k(es.$$.fragment,a),k(ga.$$.fragment,a),k(ts.$$.fragment,a),k(fa.$$.fragment,a),k(as.$$.fragment,a),k(ua.$$.fragment,a),k(os.$$.fragment,a),k(cs.$$.fragment,a),k(ls.$$.fragment,a),k(ns.$$.fragment,a),k(ps.$$.fragment,a),k(is.$$.fragment,a),k(ya.$$.fragment,a),k(ds.$$.fragment,a),k(ka.$$.fragment,a),k(ja.$$.fragment,a),k(hs.$$.fragment,a),k(Aa.$$.fragment,a),k(fs.$$.fragment,a),k(Ea.$$.fragment,a),k(_s.$$.fragment,a),k(xa.$$.fragment,a),k(vs.$$.fragment,a),k(Pa.$$.fragment,a),k(ws.$$.fragment,a),k(Da.$$.fragment,a),k(ks.$$.fragment,a),k(za.$$.fragment,a),k(js.$$.fragment,a),k(Ta.$$.fragment,a),k(Oa.$$.fragment,a),k(As.$$.fragment,a),k(La.$$.fragment,a),k(Es.$$.fragment,a),k(Ia.$$.fragment,a),k(xs.$$.fragment,a),k(Sa.$$.fragment,a),k(Ds.$$.fragment,a),k(Ca.$$.fragment,a),k(qa.$$.fragment,a),k(Ts.$$.fragment,a),k(Na.$$.fragment,a),k(Os.$$.fragment,a),k(Ga.$$.fragment,a),k(Ls.$$.fragment,a),k(Va.$$.fragment,a),k(Is.$$.fragment,a),k(Wa.$$.fragment,a),Jp=!1},d(a){r(p),a&&r(u),a&&r(g),j(t),a&&r(ht),a&&r(J),a&&r(sr),a&&r(Ge),j(or),a&&r(ip),a&&r(Fs),a&&r(dp),a&&r(he),a&&r(mp),j(ft,a),a&&r(hp),a&&r(We),a&&r(gp),j(_t,a),a&&r(fp),a&&r($t),a&&r(up),a&&r(He),j(lr),a&&r(_p),a&&r(Fe),j(nr),a&&r($p),a&&r(Ye),a&&r(vp),j(pr,a),a&&r(bp),a&&r(Be),j(ir),a&&r(wp),a&&r(Je),j(dr),a&&r(yp),a&&r(kt),a&&r(kp),j(mr,a),a&&r(jp),a&&r(jt),a&&r(Ap),j(hr,a),a&&r(Ep),a&&r(Ke),j(gr),a&&r(xp),a&&r(Et),a&&r(Pp),j(fr,a),a&&r(Dp),a&&r(xt),a&&r(zp),j(ur,a),a&&r(Tp),a&&r(Qe),j(_r),a&&r(Op),a&&r(eo),a&&r(Lp),j($r,a),a&&r(Ip),j(vr,a),a&&r(Sp),a&&r(Xe),j(br),a&&r(Cp),a&&r(zt),a&&r(qp),a&&r(Ze),j(wr),a&&r(Np),a&&r(Ot),a&&r(Mp),j(yr,a),a&&r(Up),a&&r(ge),a&&r(Rp),j(kr,a),a&&r(Gp),a&&r(et),j(jr),a&&r(Vp),a&&r(Y),a&&r(Wp),a&&r(tt),j(Ar),a&&r(Hp),a&&r(qt),a&&r(Fp),j(Er,a),a&&r(Yp),a&&r(at),j(xr),a&&r(Bp),a&&r(E),j(Pr),j(Dr),j(Jt),j(zr),j(Kt),j(Tr),j(Qt),j(Lr),j(Xt),j(Sr),j(Zt),j(qr),j(ea),j(Mr),j(ta),j(Ur),j(aa),j(Rr),j(ra),j(Vr),j(sa),j(Hr),j(oa),j(Yr),j(ca),j(Br),j(la),j(Kr),j(na),j(pa),j(ia),j(Xr),j(da),j(ma),j(Zr),j(ha),j(es),j(ga),j(ts),j(fa),j(as),j(ua),j(os),j(cs),j(ls),j(ns),j(ps),j(is),j(ya),j(ds),j(ka),j(ja),j(hs),j(Aa),j(fs),j(Ea),j(_s),j(xa),j(vs),j(Pa),j(ws),j(Da),j(ks),j(za),j(js),j(Ta),j(Oa),j(As),j(La),j(Es),j(Ia),j(xs),j(Sa),j(Ds),j(Ca),j(qa),j(Ts),j(Na),j(Os),j(Ga),j(Ls),j(Va),j(Is),j(Wa)}}}const aw={local:"accelerator",sections:[{local:"quick-adaptation-of-your-code",title:"Quick adaptation of your code"},{local:"advanced-recommendations",sections:[{local:"printing",title:"Printing"},{local:"executing-processes",sections:[{local:"once-on-a-single-server",title:"Once on a single server"},{local:"only-ever-once-across-all-servers",title:"Only ever once across all servers"},{local:"on-specific-processes",title:"On specific processes"}],title:"Executing processes"},{local:"synchronicity-control",title:"Synchronicity control"},{local:"saving-and-loading",title:"Saving and loading"},{local:"operations",title:"Operations"},{local:"gradient-accumulation",title:"Gradient Accumulation"}],title:"Advanced recommendations"},{local:"accelerate.Accelerator",title:"Overall API documentation:"}],title:"Accelerator"};function rw(x){return i2(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class iw extends c2{constructor(p){super();l2(this,p,rw,tw,n2,{})}}export{iw as default,aw as metadata};
